;
(function (a) {
    a.fn.zclip = function (c) {
        if (typeof c == "object" && !c.length) {
            var b = a.extend({
                path: "ZeroClipboard.swf",
                copy: null,
                beforeCopy: null,
                afterCopy: null,
                clickAfter: true,
                setHandCursor: true,
                setCSSEffects: true
            }, c);
            return this.each(function () {
                var e = a(this);
                if (e.is(":visible") && (typeof b.copy == "string" || a.isFunction(b.copy))) {
                    ZeroClipboard.setMoviePath(b.path);
                    var d = new ZeroClipboard.Client();
                    if (a.isFunction(b.copy)) {
                        e.bind("zClip_copy", b.copy)
                    }
                    if (a.isFunction(b.beforeCopy)) {
                        e.bind("zClip_beforeCopy", b.beforeCopy)
                    }
                    if (a.isFunction(b.afterCopy)) {
                        e.bind("zClip_afterCopy", b.afterCopy)
                    }
                    d.setHandCursor(b.setHandCursor);
                    d.setCSSEffects(b.setCSSEffects);
                    d.addEventListener("mouseOver", function (f) {
                        e.trigger("mouseenter")
                    });
                    d.addEventListener("mouseOut", function (f) {
                        e.trigger("mouseleave")
                    });
                    d.addEventListener("mouseDown", function (f) {
                        e.trigger("mousedown");
                        if (!a.isFunction(b.copy)) {
                            d.setText(b.copy)
                        } else {
                            d.setText(e.triggerHandler("zClip_copy"))
                        } if (a.isFunction(b.beforeCopy)) {
                            e.trigger("zClip_beforeCopy")
                        }
                    });
                    d.addEventListener("complete", function (f, g) {
                        if (a.isFunction(b.afterCopy)) {
                            e.trigger("zClip_afterCopy")
                        } else {
                            if (g.length > 500) {
                                g = g.substr(0, 500) + "...\n\n(" + (g.length - 500) + " characters not shown)"
                            }
                            e.removeClass("hover");
                            alert("Copied text to clipboard:\n\n " + g)
                        } if (b.clickAfter) {
                            e.trigger("click")
                        }
                    });
                    d.glue(e[0], e.parent()[0]);
                    a(window).bind("load resize", function () {
                        d.reposition()
                    })
                }
            })
        } else {
            if (typeof c == "string") {
                return this.each(function () {
                    var f = a(this);
                    c = c.toLowerCase();
                    var e = f.data("zclipId");
                    var d = a("#" + e + ".zclip");
                    if (c == "remove") {
                        d.remove();
                        f.removeClass("active hover")
                    } else {
                        if (c == "hide") {
                            d.hide();
                            f.removeClass("active hover")
                        } else {
                            if (c == "show") {
                                d.show()
                            }
                        }
                    }
                })
            }
        }
    }
})(jQuery);
var ZeroClipboard = {
    version: "1.0.7",
    clients: {},
    moviePath: "ZeroClipboard.swf",
    nextId: 1,
    $: function (a) {
        if (typeof (a) == "string") {
            a = document.getElementById(a)
        }
        if (!a.addClass) {
            a.hide = function () {
                this.style.display = "none"
            };
            a.show = function () {
                this.style.display = ""
            };
            a.addClass = function (b) {
                this.removeClass(b);
                this.className += " " + b
            };
            a.removeClass = function (d) {
                var e = this.className.split(/\s+/);
                var b = -1;
                for (var c = 0; c < e.length; c++) {
                    if (e[c] == d) {
                        b = c;
                        c = e.length
                    }
                }
                if (b > -1) {
                    e.splice(b, 1);
                    this.className = e.join(" ")
                }
                return this
            };
            a.hasClass = function (b) {
                return !!this.className.match(new RegExp("\\s*" + b + "\\s*"))
            }
        }
        return a
    },
    setMoviePath: function (a) {
        this.moviePath = a
    },
    dispatch: function (d, b, c) {
        var a = this.clients[d];
        if (a) {
            a.receiveEvent(b, c)
        }
    },
    register: function (b, a) {
        this.clients[b] = a
    },
    getDOMObjectPosition: function (c, a) {
        var b = {
            left: 0,
            top: 0,
            width: c.width ? c.width : c.offsetWidth,
            height: c.height ? c.height : c.offsetHeight
        };
        if (c && (c != a)) {
            b.left += c.offsetLeft;
            b.top += c.offsetTop
        }
        return b
    },
    Client: function (a) {
        this.handlers = {};
        this.id = ZeroClipboard.nextId++;
        this.movieId = "ZeroClipboardMovie_" + this.id;
        ZeroClipboard.register(this.id, this);
        if (a) {
            this.glue(a)
        }
    }
};
ZeroClipboard.Client.prototype = {
    id: 0,
    ready: false,
    movie: null,
    clipText: "",
    handCursorEnabled: true,
    cssEffects: true,
    handlers: null,
    glue: function (d, b, e) {
        this.domElement = ZeroClipboard.$(d);
        var f = 99;
        if (this.domElement.style.zIndex) {
            f = parseInt(this.domElement.style.zIndex, 10) + 1
        }
        if (typeof (b) == "string") {
            b = ZeroClipboard.$(b)
        } else {
            if (typeof (b) == "undefined") {
                b = document.getElementsByTagName("body")[0]
            }
        }
        var c = ZeroClipboard.getDOMObjectPosition(this.domElement, b);
        this.div = document.createElement("div");
        this.div.className = "zclip";
        this.div.id = "zclip-" + this.movieId;
        $(this.domElement).data("zclipId", "zclip-" + this.movieId);
        var a = this.div.style;
        a.position = "absolute";
        a.left = "" + c.left + "px";
        a.top = "" + c.top + "px";
        a.width = "" + c.width + "px";
        a.height = "" + c.height + "px";
        a.zIndex = f;
        if (typeof (e) == "object") {
            for (addedStyle in e) {
                a[addedStyle] = e[addedStyle]
            }
        }
        b.appendChild(this.div);
        this.div.innerHTML = this.getHTML(c.width, c.height)
    },
    getHTML: function (d, a) {
        var c = "";
        var b = "id=" + this.id + "&width=" + d + "&height=" + a;
        if (navigator.userAgent.match(/MSIE/)) {
            var e = location.href.match(/^https/i) ? "https://" : "http://";
            c += '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="' + e + 'download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0" width="' + d + '" height="' + a + '" id="' + this.movieId + '" align="middle"><param name="allowScriptAccess" value="always" /><param name="allowFullScreen" value="false" /><param name="movie" value="' + ZeroClipboard.moviePath + '" /><param name="loop" value="false" /><param name="menu" value="false" /><param name="quality" value="best" /><param name="bgcolor" value="#ffffff" /><param name="flashvars" value="' + b + '"/><param name="wmode" value="transparent"/></object>'
        } else {
            c += '<embed id="' + this.movieId + '" src="' + ZeroClipboard.moviePath + '" loop="false" menu="false" quality="best" bgcolor="#ffffff" width="' + d + '" height="' + a + '" name="' + this.movieId + '" align="middle" allowScriptAccess="always" allowFullScreen="false" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" flashvars="' + b + '" wmode="transparent" />'
        }
        return c
    },
    hide: function () {
        if (this.div) {
            this.div.style.left = "-2000px"
        }
    },
    show: function () {
        this.reposition()
    },
    destroy: function () {
        if (this.domElement && this.div) {
            this.hide();
            this.div.innerHTML = "";
            var a = document.getElementsByTagName("body")[0];
            try {
                a.removeChild(this.div)
            } catch (b) {}
            this.domElement = null;
            this.div = null
        }
    },
    reposition: function (c) {
        if (c) {
            this.domElement = ZeroClipboard.$(c);
            if (!this.domElement) {
                this.hide()
            }
        }
        if (this.domElement && this.div) {
            var b = ZeroClipboard.getDOMObjectPosition(this.domElement);
            var a = this.div.style;
            a.left = "" + b.left + "px";
            a.top = "" + b.top + "px"
        }
    },
    setText: function (a) {
        this.clipText = a;
        if (this.ready) {
            this.movie.setText(a)
        }
    },
    addEventListener: function (a, b) {
        a = a.toString().toLowerCase().replace(/^on/, "");
        if (!this.handlers[a]) {
            this.handlers[a] = []
        }
        this.handlers[a].push(b)
    },
    setHandCursor: function (a) {
        this.handCursorEnabled = a;
        if (this.ready) {
            this.movie.setHandCursor(a)
        }
    },
    setCSSEffects: function (a) {
        this.cssEffects = !! a
    },
    receiveEvent: function (d, f) {
        d = d.toString().toLowerCase().replace(/^on/, "");
        switch (d) {
        case "load":
            this.movie = document.getElementById(this.movieId);
            if (!this.movie) {
                var c = this;
                setTimeout(function () {
                    c.receiveEvent("load", null)
                }, 1);
                return
            }
            if (!this.ready && navigator.userAgent.match(/Firefox/) && navigator.userAgent.match(/Windows/)) {
                var c = this;
                setTimeout(function () {
                    c.receiveEvent("load", null)
                }, 100);
                this.ready = true;
                return
            }
            this.ready = true;
            try {
                this.movie.setText(this.clipText)
            } catch (h) {}
            try {
                this.movie.setHandCursor(this.handCursorEnabled)
            } catch (h) {}
            break;
        case "mouseover":
            if (this.domElement && this.cssEffects) {
                this.domElement.addClass("hover");
                if (this.recoverActive) {
                    this.domElement.addClass("active")
                }
            }
            break;
        case "mouseout":
            if (this.domElement && this.cssEffects) {
                this.recoverActive = false;
                if (this.domElement.hasClass("active")) {
                    this.domElement.removeClass("active");
                    this.recoverActive = true
                }
                this.domElement.removeClass("hover")
            }
            break;
        case "mousedown":
            if (this.domElement && this.cssEffects) {
                this.domElement.addClass("active")
            }
            break;
        case "mouseup":
            if (this.domElement && this.cssEffects) {


                this.domElement.removeClass("active");
                this.recoverActive = false
            }
            break
        }
        if (this.handlers[d]) {
            for (var b = 0, a = this.handlers[d].length; b < a; b++) {
                var g = this.handlers[d][b];
                if (typeof (g) == "function") {
                    g(this, f)
                } else {
                    if ((typeof (g) == "object") && (g.length == 2)) {
                        g[0][g[1]](this, f)
                    } else {
                        if (typeof (g) == "string") {
                            window[g](this, f)
                        }
                    }
                }
            }
        }
    }
};;
(function (c) {
    c.extend(c.fn, {
        validate: function (a) {
            if (this.length) {
                var b = c.data(this[0], "validator");
                if (b) return b;
                this.attr("novalidate", "novalidate");
                b = new c.validator(a, this[0]);
                c.data(this[0], "validator", b);
                if (b.settings.onsubmit) {
                    a = this.find("input, button");
                    a.filter(".cancel").click(function () {
                        b.cancelSubmit = true
                    });
                    b.settings.submitHandler && a.filter(":submit").click(function () {
                        b.submitButton = this
                    });
                    this.submit(function (d) {
                        function e() {
                            if (b.settings.submitHandler) {
                                if (b.submitButton) var f = c("<input type='hidden'/>").attr("name", b.submitButton.name).val(b.submitButton.value).appendTo(b.currentForm);
                                b.settings.submitHandler.call(b, b.currentForm);
                                b.submitButton && f.remove();
                                return false
                            }
                            return true
                        }
                        b.settings.debug && d.preventDefault();
                        if (b.cancelSubmit) {
                            b.cancelSubmit = false;
                            return e()
                        }
                        if (b.form()) {
                            if (b.pendingRequest) {
                                b.formSubmitted = true;
                                return false
                            }
                            return e()
                        } else {
                            b.focusInvalid();
                            return false
                        }
                    })
                }
                return b
            } else a && a.debug && window.console && console.warn("nothing selected, can't validate, returning nothing")
        },
        valid: function () {
            if (c(this[0]).is("form")) return this.validate().form();
            else {
                var a = true,
                    b = c(this[0].form).validate();
                this.each(function () {
                    a &= b.element(this)
                });
                return a
            }
        },
        removeAttrs: function (a) {
            var b = {}, d = this;
            c.each(a.split(/\s/), function (e, f) {
                b[f] = d.attr(f);
                d.removeAttr(f)
            });
            return b
        },
        rules: function (a, b) {
            var d = this[0];
            if (a) {
                var e = c.data(d.form, "validator").settings,
                    f = e.rules,
                    g = c.validator.staticRules(d);
                switch (a) {
                case "add":
                    c.extend(g, c.validator.normalizeRule(b));
                    f[d.name] = g;
                    if (b.messages) e.messages[d.name] = c.extend(e.messages[d.name], b.messages);
                    break;

                case "remove":
                    if (!b) {
                        delete f[d.name];
                        return g
                    }
                    var h = {};
                    c.each(b.split(/\s/), function (j, i) {
                        h[i] = g[i];
                        delete g[i]
                    });
                    return h
                }
            }
            d = c.validator.normalizeRules(c.extend({}, c.validator.metadataRules(d), c.validator.classRules(d), c.validator.attributeRules(d), c.validator.staticRules(d)), d);
            if (d.required) {
                e = d.required;
                delete d.required;
                d = c.extend({
                    required: e
                }, d)
            }
            return d
        }
    });
    c.extend(c.expr[":"], {
        blank: function (a) {
            return !c.trim("" + a.value)
        },
        filled: function (a) {
            return !!c.trim("" + a.value)
        },
        unchecked: function (a) {
            return !a.checked
        }
    });
    c.validator = function (a, b) {
        this.settings = c.extend(true, {}, c.validator.defaults, a);
        this.currentForm = b;
        this.init()
    };
    c.validator.format = function (a, b) {
        if (arguments.length == 1) return function () {
            var d = c.makeArray(arguments);
            d.unshift(a);
            return c.validator.format.apply(this, d)
        };
        if (arguments.length > 2 && b.constructor != Array) b = c.makeArray(arguments).slice(1);
        if (b.constructor != Array) b = [b];
        c.each(b, function (d, e) {
            a = a.replace(RegExp("\\{" + d + "\\}", "g"), e)
        });
        return a
    };
    c.extend(c.validator, {
        defaults: {
            messages: {},
            groups: {},
            rules: {},
            errorClass: "error",
            validClass: "valid",
            errorElement: "label",
            focusInvalid: true,
            errorContainer: c([]),
            errorLabelContainer: c([]),
            onsubmit: true,
            ignore: ":hidden",
            ignoreTitle: false,
            onfocusin: function (a) {
                this.lastActive = a;
                if (this.settings.focusCleanup && !this.blockFocusCleanup) {
                    this.settings.unhighlight && this.settings.unhighlight.call(this, a, this.settings.errorClass, this.settings.validClass);
                    this.addWrapper(this.errorsFor(a)).hide()
                }
            },
            onfocusout: function (a) {
                if (!this.checkable(a) && (a.name in this.submitted || !this.optional(a))) this.element(a)
            },
            onkeyup: function (a) {
                if (a.name in this.submitted || a == this.lastElement) this.element(a)
            },
            onclick: function (a) {
                if (a.name in this.submitted) this.element(a);
                else a.parentNode.name in this.submitted && this.element(a.parentNode)
            },
            highlight: function (a, b, d) {
                a.type === "radio" ? this.findByName(a.name).addClass(b).removeClass(d) : c(a).addClass(b).removeClass(d)
            },
            unhighlight: function (a, b, d) {
                a.type === "radio" ? this.findByName(a.name).removeClass(b).addClass(d) : c(a).removeClass(b).addClass(d)
            }
        },
        setDefaults: function (a) {
            c.extend(c.validator.defaults, a)
        },
        messages: {
            required: "This field is required.",
            remote: "Please fix this field.",
            email: "Please enter a valid email address.",
            url: "Please enter a valid URL.",
            date: "Please enter a valid date.",
            dateISO: "Please enter a valid date (ISO).",
            number: "Please enter a valid number.",
            digits: "Please enter only digits.",
            creditcard: "Please enter a valid credit card number.",
            equalTo: "Please enter the same value again.",
            accept: "Please enter a value with a valid extension.",
            maxlength: c.validator.format("Please enter no more than {0} characters."),
            minlength: c.validator.format("Please enter at least {0} characters."),
            rangelength: c.validator.format("Please enter a value between {0} and {1} characters long."),
            range: c.validator.format("Please enter a value between {0} and {1}."),
            max: c.validator.format("Please enter a value less than or equal to {0}."),
            min: c.validator.format("Please enter a value greater than or equal to {0}.")
        },
        autoCreateRanges: false,
        prototype: {
            init: function () {
                function a(e) {
                    var f = c.data(this[0].form, "validator"),
                        g = "on" + e.type.replace(/^validate/, "");
                    f.settings[g] && f.settings[g].call(f, this[0], e)
                }
                this.labelContainer = c(this.settings.errorLabelContainer);
                this.errorContext = this.labelContainer.length && this.labelContainer || c(this.currentForm);
                this.containers = c(this.settings.errorContainer).add(this.settings.errorLabelContainer);
                this.submitted = {};
                this.valueCache = {};
                this.pendingRequest = 0;
                this.pending = {};
                this.invalid = {};
                this.reset();
                var b = this.groups = {};
                c.each(this.settings.groups, function (e, f) {
                    c.each(f.split(/\s/), function (g, h) {
                        b[h] = e
                    })
                });
                var d = this.settings.rules;
                c.each(d, function (e, f) {
                    d[e] = c.validator.normalizeRule(f)
                });
                c(this.currentForm).validateDelegate("[type='text'], [type='password'], [type='file'], select, textarea, [type='number'], [type='search'] ,[type='tel'], [type='url'], [type='email'], [type='datetime'], [type='date'], [type='month'], [type='week'], [type='time'], [type='datetime-local'], [type='range'], [type='color'] ", "focusin focusout keyup", a).validateDelegate("[type='radio'], [type='checkbox'], select, option", "click", a);
                this.settings.invalidHandler && c(this.currentForm).bind("invalid-form.validate", this.settings.invalidHandler)
            },
            form: function () {
                this.checkForm();
                c.extend(this.submitted, this.errorMap);
                this.invalid = c.extend({}, this.errorMap);
                this.valid() || c(this.currentForm).triggerHandler("invalid-form", [this]);
                this.showErrors();
                return this.valid()
            },
            checkForm: function () {
                this.prepareForm();
                for (var a = 0, b = this.currentElements = this.elements(); b[a]; a++) this.check(b[a]);
                return this.valid()
            },
            element: function (a) {
                this.lastElement = a = this.validationTargetFor(this.clean(a));
                this.prepareElement(a);
                this.currentElements = c(a);
                var b = this.check(a);
                if (b) delete this.invalid[a.name];
                else this.invalid[a.name] = true; if (!this.numberOfInvalids()) this.toHide = this.toHide.add(this.containers);
                this.showErrors();
                return b
            },
            showErrors: function (a) {
                if (a) {
                    c.extend(this.errorMap, a);
                    this.errorList = [];
                    for (var b in a) this.errorList.push({
                        message: a[b],
                        element: this.findByName(b)[0]
                    });
                    this.successList = c.grep(this.successList, function (d) {
                        return !(d.name in a)
                    })
                }
                this.settings.showErrors ? this.settings.showErrors.call(this, this.errorMap, this.errorList) : this.defaultShowErrors()
            },
            resetForm: function () {
                c.fn.resetForm && c(this.currentForm).resetForm();
                this.submitted = {};
                this.lastElement = null;
                this.prepareForm();
                this.hideErrors();
                this.elements().removeClass(this.settings.errorClass)
            },
            numberOfInvalids: function () {
                return this.objectLength(this.invalid)
            },
            objectLength: function (a) {
                var b = 0,
                    d;
                for (d in a) b++;
                return b
            },
            hideErrors: function () {
                this.addWrapper(this.toHide).hide()
            },
            valid: function () {
                return this.size() == 0
            },
            size: function () {
                return this.errorList.length
            },
            focusInvalid: function () {
                if (this.settings.focusInvalid) try {
                    c(this.findLastActive() || this.errorList.length && this.errorList[0].element || []).filter(":visible").focus().trigger("focusin")
                } catch (a) {}
            },
            findLastActive: function () {
                var a = this.lastActive;
                return a && c.grep(this.errorList, function (b) {
                    return b.element.name == a.name
                }).length == 1 && a
            },
            elements: function () {
                var a = this,
                    b = {};
                return c(this.currentForm).find("input, select, textarea").not(":submit, :reset, :image, [disabled]").not(this.settings.ignore).filter(function () {
                    !this.name && a.settings.debug && window.console && console.error("%o has no name assigned", this);
                    if (this.name in b || !a.objectLength(c(this).rules())) return false;
                    return b[this.name] = true
                })
            },
            clean: function (a) {
                return c(a)[0]
            },
            errors: function () {
                return c(this.settings.errorElement + "." + this.settings.errorClass, this.errorContext)
            },
            reset: function () {
                this.successList = [];
                this.errorList = [];
                this.errorMap = {};
                this.toShow = c([]);
                this.toHide = c([]);
                this.currentElements = c([])
            },
            prepareForm: function () {
                this.reset();
                this.toHide = this.errors().add(this.containers)
            },
            prepareElement: function (a) {
                this.reset();
                this.toHide = this.errorsFor(a)
            },
            check: function (a) {
                a = this.validationTargetFor(this.clean(a));
                var b = c(a).rules(),
                    d = false,
                    e;
                for (e in b) {
                    var f = {
                        method: e,
                        parameters: b[e]
                    };
                    try {
                        var g = c.validator.methods[e].call(this, a.value.replace(/\r/g, ""), a, f.parameters);
                        if (g == "dependency-mismatch") d = true;
                        else {
                            d = false;
                            if (g == "pending") {
                                this.toHide = this.toHide.not(this.errorsFor(a));
                                return
                            }
                            if (!g) {
                                this.formatAndAdd(a, f);
                                return false
                            }
                        }
                    } catch (h) {
                        this.settings.debug && window.console && console.log("exception occured when checking element " +
                            a.id + ", check the '" + f.method + "' method", h);
                        throw h;
                    }
                }
                if (!d) {
                    this.objectLength(b) && this.successList.push(a);
                    return true
                }
            },
            customMetaMessage: function (a, b) {
                if (c.metadata) {
                    var d = this.settings.meta ? c(a).metadata()[this.settings.meta] : c(a).metadata();
                    return d && d.messages && d.messages[b]
                }
            },
            customMessage: function (a, b) {
                var d = this.settings.messages[a];
                return d && (d.constructor == String ? d : d[b])
            },
            findDefined: function () {
                for (var a = 0; a < arguments.length; a++)
                    if (arguments[a] !== undefined) return arguments[a]
            },
            defaultMessage: function (a, b) {
                return this.findDefined(this.customMessage(a.name, b), this.customMetaMessage(a, b), !this.settings.ignoreTitle && a.title || undefined, c.validator.messages[b], "<strong>Warning: No message defined for " + a.name + "</strong>")
            },
            formatAndAdd: function (a, b) {
                var d = this.defaultMessage(a, b.method),
                    e = /\$?\{(\d+)\}/g;
                if (typeof d == "function") d = d.call(this, b.parameters, a);
                else if (e.test(d)) d = jQuery.format(d.replace(e, "{$1}"), b.parameters);
                this.errorList.push({
                    message: d,
                    element: a
                });
                this.errorMap[a.name] = d;
                this.submitted[a.name] = d
            },
            addWrapper: function (a) {
                if (this.settings.wrapper) a = a.add(a.parent(this.settings.wrapper));
                return a
            },
            defaultShowErrors: function () {
                for (var a = 0; this.errorList[a]; a++) {
                    var b = this.errorList[a];
                    this.settings.highlight && this.settings.highlight.call(this, b.element, this.settings.errorClass, this.settings.validClass);
                    this.showLabel(b.element, b.message)
                }
                if (this.errorList.length) this.toShow = this.toShow.add(this.containers);
                if (this.settings.success)
                    for (a = 0; this.successList[a]; a++) this.showLabel(this.successList[a]);
                if (this.settings.unhighlight) {
                    a = 0;
                    for (b = this.validElements(); b[a]; a++) this.settings.unhighlight.call(this, b[a], this.settings.errorClass, this.settings.validClass)
                }
                this.toHide = this.toHide.not(this.toShow);
                this.hideErrors();
                this.addWrapper(this.toShow).show()
            },
            validElements: function () {
                return this.currentElements.not(this.invalidElements())
            },
            invalidElements: function () {
                return c(this.errorList).map(function () {
                    return this.element
                })
            },
            showLabel: function (a, b) {
                var d = this.errorsFor(a);
                if (d.length) {
                    d.removeClass(this.settings.validClass).addClass(this.settings.errorClass);
                    d.attr("generated") && d.html(b)
                } else {
                    d = c("<" + this.settings.errorElement + "/>").attr({
                        "for": this.idOrName(a),
                        generated: true
                    }).addClass(this.settings.errorClass).html(b || "");
                    if (this.settings.wrapper) d = d.hide().show().wrap("<" + this.settings.wrapper + "/>").parent();
                    this.labelContainer.append(d).length || (this.settings.errorPlacement ? this.settings.errorPlacement(d, c(a)) : d.insertAfter(a))
                } if (!b && this.settings.success) {
                    d.text("");
                    typeof this.settings.success == "string" ? d.addClass(this.settings.success) : this.settings.success(d)
                }
                this.toShow = this.toShow.add(d)
            },
            errorsFor: function (a) {
                var b = this.idOrName(a);
                return this.errors().filter(function () {
                    return c(this).attr("for") == b
                })
            },
            idOrName: function (a) {
                return this.groups[a.name] || (this.checkable(a) ? a.name : a.id || a.name)
            },
            validationTargetFor: function (a) {
                if (this.checkable(a)) a = this.findByName(a.name).not(this.settings.ignore)[0];
                return a
            },
            checkable: function (a) {
                return /radio|checkbox/i.test(a.type)
            },
            findByName: function (a) {
                var b = this.currentForm;
                return c(document.getElementsByName(a)).map(function (d, e) {
                    return e.form == b && e.name == a && e || null
                })
            },
            getLength: function (a, b) {
                switch (b.nodeName.toLowerCase()) {
                case "select":
                    return c("option:selected", b).length;
                case "input":
                    if (this.checkable(b)) return this.findByName(b.name).filter(":checked").length
                }
                return a.length
            },
            depend: function (a, b) {
                return this.dependTypes[typeof a] ? this.dependTypes[typeof a](a, b) : true
            },
            dependTypes: {
                "boolean": function (a) {
                    return a
                },
                string: function (a, b) {
                    return !!c(a, b.form).length
                },
                "function": function (a, b) {
                    return a(b)
                }
            },
            optional: function (a) {
                return !c.validator.methods.required.call(this, c.trim(a.value), a) && "dependency-mismatch"
            },
            startRequest: function (a) {
                if (!this.pending[a.name]) {
                    this.pendingRequest++;
                    this.pending[a.name] = true
                }
            },
            stopRequest: function (a, b) {
                this.pendingRequest--;
                if (this.pendingRequest < 0) this.pendingRequest = 0;
                delete this.pending[a.name];
                if (b && this.pendingRequest == 0 && this.formSubmitted && this.form()) {
                    c(this.currentForm).submit();
                    this.formSubmitted = false
                } else if (!b && this.pendingRequest == 0 && this.formSubmitted) {
                    c(this.currentForm).triggerHandler("invalid-form", [this]);
                    this.formSubmitted = false
                }
            },
            previousValue: function (a) {
                return c.data(a, "previousValue") || c.data(a, "previousValue", {
                    old: null,
                    valid: true,
                    message: this.defaultMessage(a, "remote")
                })
            }
        },
        classRuleSettings: {
            required: {
                required: true
            },
            email: {
                email: true
            },
            url: {
                url: true
            },
            date: {
                date: true
            },
            dateISO: {
                dateISO: true
            },
            dateDE: {
                dateDE: true
            },
            number: {
                number: true
            },
            numberDE: {
                numberDE: true
            },
            digits: {
                digits: true
            },
            creditcard: {
                creditcard: true
            }
        },
        addClassRules: function (a, b) {
            a.constructor == String ? this.classRuleSettings[a] = b : c.extend(this.classRuleSettings, a)
        },
        classRules: function (a) {
            var b = {};
            (a = c(a).attr("class")) && c.each(a.split(" "), function () {
                this in c.validator.classRuleSettings && c.extend(b, c.validator.classRuleSettings[this])
            });
            return b
        },
        attributeRules: function (a) {
            var b = {};
            a = c(a);
            for (var d in c.validator.methods) {
                var e;
                if (e = d === "required" && typeof c.fn.prop === "function" ? a.prop(d) : a.attr(d)) b[d] = e;
                else if (a[0].getAttribute("type") === d) b[d] = true
            }
            b.maxlength && /-1|2147483647|524288/.test(b.maxlength) && delete b.maxlength;
            return b
        },
        metadataRules: function (a) {
            if (!c.metadata) return {};
            var b = c.data(a.form, "validator").settings.meta;
            return b ? c(a).metadata()[b] : c(a).metadata()
        },
        staticRules: function (a) {
            var b = {}, d = c.data(a.form, "validator");
            if (d.settings.rules) b = c.validator.normalizeRule(d.settings.rules[a.name]) || {};
            return b
        },
        normalizeRules: function (a, b) {
            c.each(a, function (d, e) {
                if (e === false) delete a[d];
                else if (e.param || e.depends) {
                    var f = true;
                    switch (typeof e.depends) {
                    case "string":
                        f = !! c(e.depends, b.form).length;
                        break;
                    case "function":
                        f = e.depends.call(b, b)
                    }
                    if (f) a[d] = e.param !== undefined ? e.param : true;
                    else delete a[d]
                }
            });
            c.each(a, function (d, e) {
                a[d] = c.isFunction(e) ? e(b) : e
            });
            c.each(["minlength", "maxlength", "min", "max"], function () {
                if (a[this]) a[this] = Number(a[this])
            });
            c.each(["rangelength", "range"], function () {
                if (a[this]) a[this] = [Number(a[this][0]), Number(a[this][1])]
            });
            if (c.validator.autoCreateRanges) {
                if (a.min && a.max) {
                    a.range = [a.min, a.max];
                    delete a.min;
                    delete a.max
                }
                if (a.minlength && a.maxlength) {
                    a.rangelength = [a.minlength, a.maxlength];
                    delete a.minlength;
                    delete a.maxlength
                }
            }
            a.messages && delete a.messages;
            return a
        },
        normalizeRule: function (a) {
            if (typeof a == "string") {
                var b = {};
                c.each(a.split(/\s/), function () {
                    b[this] = true
                });
                a = b
            }
            return a
        },
        addMethod: function (a, b, d) {
            c.validator.methods[a] = b;
            c.validator.messages[a] = d != undefined ? d : c.validator.messages[a];
            b.length < 3 && c.validator.addClassRules(a, c.validator.normalizeRule(a))
        },
        methods: {
            required: function (a, b, d) {
                if (!this.depend(d, b)) return "dependency-mismatch";
                switch (b.nodeName.toLowerCase()) {
                case "select":
                    return (a = c(b).val()) && a.length > 0;
                case "input":
                    if (this.checkable(b)) return this.getLength(a, b) > 0;
                default:
                    return c.trim(a).length > 0
                }
            },
            remote: function (a, b, d) {
                if (this.optional(b)) return "dependency-mismatch";
                var e = this.previousValue(b);
                this.settings.messages[b.name] || (this.settings.messages[b.name] = {});
                e.originalMessage = this.settings.messages[b.name].remote;
                this.settings.messages[b.name].remote = e.message;
                d = typeof d == "string" && {
                    url: d
                } || d;
                if (this.pending[b.name]) return "pending";
                if (e.old === a) return e.valid;
                e.old = a;
                var f = this;
                this.startRequest(b);
                var g = {};
                g[b.name] = a;
                c.ajax(c.extend(true, {
                    url: d,
                    mode: "abort",
                    port: "validate" + b.name,
                    dataType: "json",
                    data: g,
                    success: function (h) {
                        f.settings.messages[b.name].remote = e.originalMessage;
                        var j = h === true;
                        if (j) {
                            var i = f.formSubmitted;
                            f.prepareElement(b);
                            f.formSubmitted = i;
                            f.successList.push(b);
                            f.showErrors()
                        } else {
                            i = {};
                            h = h || f.defaultMessage(b, "remote");
                            i[b.name] = e.message = c.isFunction(h) ? h(a) : h;
                            f.showErrors(i)
                        }
                        e.valid = j;
                        f.stopRequest(b, j)
                    }
                }, d));
                return "pending"
            },
            minlength: function (a, b, d) {
                return this.optional(b) || this.getLength(c.trim(a), b) >= d
            },
            maxlength: function (a, b, d) {
                return this.optional(b) || this.getLength(c.trim(a), b) <= d
            },
            rangelength: function (a, b, d) {
                a = this.getLength(c.trim(a), b);
                return this.optional(b) || a >= d[0] && a <= d[1]
            },
            min: function (a, b, d) {
                return this.optional(b) || a >= d
            },
            max: function (a, b, d) {
                return this.optional(b) || a <= d
            },
            range: function (a, b, d) {
                return this.optional(b) || a >= d[0] && a <= d[1]
            },
            email: function (a, b) {
                return this.optional(b) || /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i.test(a)
            },
            url: function (a, b) {
                return this.optional(b) || /^(https?|ftp):\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i.test(a)
            },
            date: function (a, b) {
                return this.optional(b) || !/Invalid|NaN/.test(new Date(a))
            },
            dateISO: function (a, b) {
                return this.optional(b) || /^\d{4}[\/-]\d{1,2}[\/-]\d{1,2}$/.test(a)
            },
            number: function (a, b) {
                return this.optional(b) || /^-?(?:\d+|\d{1,3}(?:,\d{3})+)(?:\.\d+)?$/.test(a)
            },
            digits: function (a, b) {
                return this.optional(b) || /^\d+$/.test(a)
            },
            creditcard: function (a, b) {
                if (this.optional(b)) return "dependency-mismatch";
                if (/[^0-9 -]+/.test(a)) return false;
                var d = 0,
                    e = 0,
                    f = false;
                a = a.replace(/\D/g, "");
                for (var g = a.length - 1; g >= 0; g--) {
                    e = a.charAt(g);
                    e = parseInt(e, 10);
                    if (f)
                        if ((e *= 2) > 9) e -= 9;
                    d += e;
                    f = !f
                }
                return d % 10 == 0
            },
            accept: function (a, b, d) {
                d = typeof d == "string" ? d.replace(/,/g, "|") : "png|jpe?g|gif";
                return this.optional(b) || a.match(RegExp(".(" + d + ")$", "i"))
            },
            equalTo: function (a, b, d) {
                d = c(d).unbind(".validate-equalTo").bind("blur.validate-equalTo", function () {
                    c(b).valid()
                });
                return a == d.val()
            }
        }
    });
    c.format = c.validator.format
})(jQuery);
(function (c) {
    var a = {};
    if (c.ajaxPrefilter) c.ajaxPrefilter(function (d, e, f) {
        e = d.port;
        if (d.mode == "abort") {
            a[e] && a[e].abort();
            a[e] = f
        }
    });
    else {
        var b = c.ajax;
        c.ajax = function (d) {
            var e = ("port" in d ? d : c.ajaxSettings).port;
            if (("mode" in d ? d : c.ajaxSettings).mode == "abort") {
                a[e] && a[e].abort();
                return a[e] = b.apply(this, arguments)
            }
            return b.apply(this, arguments)
        }
    }
})(jQuery);
(function (c) {
    !jQuery.event.special.focusin && !jQuery.event.special.focusout && document.addEventListener && c.each({
        focus: "focusin",
        blur: "focusout"
    }, function (a, b) {
        function d(e) {
            e = c.event.fix(e);
            e.type = b;
            return c.event.handle.call(this, e)
        }
        c.event.special[b] = {
            setup: function () {
                this.addEventListener(a, d, true)
            },
            teardown: function () {
                this.removeEventListener(a, d, true)
            },
            handler: function (e) {
                arguments[0] = c.event.fix(e);
                arguments[0].type = b;
                return c.event.handle.apply(this, arguments)
            }
        }
    });
    c.extend(c.fn, {
        validateDelegate: function (a, b, d) {
            return this.bind(b, function (e) {
                var f = c(e.target);
                if (f.is(a)) return d.apply(f, arguments)
            })
        }
    })
})(jQuery);;
(function ($) {
    $.extend({
        metadata: {
            defaults: {
                type: 'class',
                name: 'metadata',
                cre: /({.*})/,
                single: 'metadata'
            },
            setType: function (type, name) {
                this.defaults.type = type;
                this.defaults.name = name;
            },
            get: function (elem, opts) {
                var settings = $.extend({}, this.defaults, opts);
                if (!settings.single.length) settings.single = 'metadata';
                var data = $.data(elem, settings.single);
                if (data) return data;
                data = "{}";
                if (settings.type == "class") {
                    var m = settings.cre.exec(elem.className);
                    if (m)
                        data = m[1];
                } else if (settings.type == "elem") {
                    if (!elem.getElementsByTagName)
                        return undefined;
                    var e = elem.getElementsByTagName(settings.name);
                    if (e.length)
                        data = $.trim(e[0].innerHTML);
                } else if (elem.getAttribute != undefined) {
                    var attr = elem.getAttribute(settings.name);
                    if (attr)
                        data = attr;
                }
                if (data.indexOf('{') < 0)
                    data = "{" + data + "}";
                data = eval("(" + data + ")");
                $.data(elem, settings.single, data);
                return data;
            }
        }
    });
    $.fn.metadata = function (opts) {
        return $.metadata.get(this[0], opts);
    };
})(jQuery);;
var q = null;
window.PR_SHOULD_USE_CONTINUATION = !0;
(function () {
    function L(a) {
        function m(a) {
            var f = a.charCodeAt(0);
            if (f !== 92) return f;
            var b = a.charAt(1);
            return (f = r[b]) ? f : "0" <= b && b <= "7" ? parseInt(a.substring(1), 8) : b === "u" || b === "x" ? parseInt(a.substring(2), 16) : a.charCodeAt(1)
        }

        function e(a) {
            if (a < 32) return (a < 16 ? "\\x0" : "\\x") + a.toString(16);
            a = String.fromCharCode(a);
            if (a === "\\" || a === "-" || a === "[" || a === "]") a = "\\" + a;
            return a
        }

        function h(a) {
            for (var f = a.substring(1, a.length - 1).match(/\\u[\dA-Fa-f]{4}|\\x[\dA-Fa-f]{2}|\\[0-3][0-7]{0,2}|\\[0-7]{1,2}|\\[\S\s]|[^\\]/g), a = [], b = [], o = f[0] === "^", c = o ? 1 : 0, i = f.length; c < i; ++c) {
                var j = f[c];
                if (/\\[bdsw]/i.test(j)) a.push(j);
                else {
                    var j = m(j),
                        d;
                    c + 2 < i && "-" === f[c + 1] ? (d = m(f[c + 2]), c += 2) : d = j;
                    b.push([j, d]);
                    d < 65 || j > 122 || (d < 65 || j > 90 || b.push([Math.max(65, j) | 32, Math.min(d, 90) | 32]), d < 97 || j > 122 || b.push([Math.max(97, j) & -33, Math.min(d, 122) & -33]))
                }
            }
            b.sort(function (a, f) {
                return a[0] - f[0] || f[1] - a[1]
            });
            f = [];
            j = [NaN, NaN];
            for (c = 0; c < b.length; ++c) i = b[c], i[0] <= j[1] + 1 ? j[1] = Math.max(j[1], i[1]) : f.push(j = i);
            b = ["["];
            o && b.push("^");
            b.push.apply(b, a);
            for (c = 0; c < f.length; ++c) i = f[c], b.push(e(i[0])), i[1] > i[0] && (i[1] + 1 > i[0] && b.push("-"), b.push(e(i[1])));
            b.push("]");
            return b.join("")
        }

        function y(a) {
            for (var f = a.source.match(/\[(?:[^\\\]]|\\[\S\s])*]|\\u[\dA-Fa-f]{4}|\\x[\dA-Fa-f]{2}|\\\d+|\\[^\dux]|\(\?[!:=]|[()^]|[^()[\\^]+/g), b = f.length, d = [], c = 0, i = 0; c < b; ++c) {
                var j = f[c];
                j === "(" ? ++i : "\\" === j.charAt(0) && (j = +j.substring(1)) && j <= i && (d[j] = -1)
            }
            for (c = 1; c < d.length; ++c) - 1 === d[c] && (d[c] = ++t);
            for (i = c = 0; c < b; ++c) j = f[c], j === "(" ? (++i, d[i] === void 0 && (f[c] = "(?:")) : "\\" === j.charAt(0) && (j = +j.substring(1)) && j <= i && (f[c] = "\\" + d[i]);
            for (i = c = 0; c < b; ++c) "^" === f[c] && "^" !== f[c + 1] && (f[c] = "");
            if (a.ignoreCase && s)
                for (c = 0; c < b; ++c) j = f[c], a = j.charAt(0), j.length >= 2 && a === "[" ? f[c] = h(j) : a !== "\\" && (f[c] = j.replace(/[A-Za-z]/g, function (a) {
                    a = a.charCodeAt(0);
                    return "[" + String.fromCharCode(a & -33, a | 32) + "]"
                }));
            return f.join("")
        }
        for (var t = 0, s = !1, l = !1, p = 0, d = a.length; p < d; ++p) {
            var g = a[p];
            if (g.ignoreCase) l = !0;
            else if (/[a-z]/i.test(g.source.replace(/\\u[\da-f]{4}|\\x[\da-f]{2}|\\[^UXux]/gi, ""))) {
                s = !0;
                l = !1;
                break
            }
        }
        for (var r = {
            b: 8,
            t: 9,
            n: 10,
            v: 11,
            f: 12,
            r: 13
        }, n = [], p = 0, d = a.length; p < d; ++p) {
            g = a[p];
            if (g.global || g.multiline) throw Error("" + g);
            n.push("(?:" + y(g) + ")")
        }
        return RegExp(n.join("|"), l ? "gi" : "g")
    }

    function M(a) {
        function m(a) {
            switch (a.nodeType) {
            case 1:
                if (e.test(a.className)) break;
                for (var g = a.firstChild; g; g = g.nextSibling) m(g);
                g = a.nodeName;
                if ("BR" === g || "LI" === g) h[s] = "\n", t[s << 1] = y++, t[s++ << 1 | 1] = a;
                break;
            case 3:
            case 4:
                g = a.nodeValue, g.length && (g = p ? g.replace(/\r\n?/g, "\n") : g.replace(/[\t\n\r ]+/g, " "), h[s] = g, t[s << 1] = y, y += g.length, t[s++ << 1 | 1] = a)
            }
        }
        var e = /(?:^|\s)nocode(?:\s|$)/,
            h = [],
            y = 0,
            t = [],
            s = 0,
            l;
        a.currentStyle ? l = a.currentStyle.whiteSpace : window.getComputedStyle && (l = document.defaultView.getComputedStyle(a, q).getPropertyValue("white-space"));
        var p = l && "pre" === l.substring(0, 3);
        m(a);
        return {
            a: h.join("").replace(/\n$/, ""),
            c: t
        }
    }

    function B(a, m, e, h) {
        m && (a = {
            a: m,
            d: a
        }, e(a), h.push.apply(h, a.e))
    }

    function x(a, m) {
        function e(a) {
            for (var l = a.d, p = [l, "pln"], d = 0, g = a.a.match(y) || [], r = {}, n = 0, z = g.length; n < z; ++n) {
                var f = g[n],
                    b = r[f],
                    o = void 0,
                    c;
                if (typeof b === "string") c = !1;
                else {
                    var i = h[f.charAt(0)];
                    if (i) o = f.match(i[1]), b = i[0];
                    else {
                        for (c = 0; c < t; ++c)
                            if (i = m[c], o = f.match(i[1])) {
                                b = i[0];
                                break
                            }
                        o || (b = "pln")
                    } if ((c = b.length >= 5 && "lang-" === b.substring(0, 5)) && !(o && typeof o[1] === "string")) c = !1, b = "src";
                    c || (r[f] = b)
                }
                i = d;
                d += f.length;
                if (c) {
                    c = o[1];
                    var j = f.indexOf(c),
                        k = j + c.length;
                    o[2] && (k = f.length - o[2].length, j = k - c.length);
                    b = b.substring(5);
                    B(l + i, f.substring(0, j), e, p);
                    B(l + i + j, c, C(b, c), p);
                    B(l + i + k, f.substring(k), e, p)
                } else p.push(l + i, b)
            }
            a.e = p
        }
        var h = {}, y;
        (function () {
            for (var e = a.concat(m), l = [], p = {}, d = 0, g = e.length; d < g; ++d) {
                var r = e[d],
                    n = r[3];
                if (n)
                    for (var k = n.length; --k >= 0;) h[n.charAt(k)] = r;
                r = r[1];
                n = "" + r;
                p.hasOwnProperty(n) || (l.push(r), p[n] = q)
            }
            l.push(/[\S\s]/);
            y = L(l)
        })();
        var t = m.length;
        return e
    }

    function u(a) {
        var m = [],
            e = [];
        a.tripleQuotedStrings ? m.push(["str", /^(?:'''(?:[^'\\]|\\[\S\s]|''?(?=[^']))*(?:'''|$)|"""(?:[^"\\]|\\[\S\s]|""?(?=[^"]))*(?:"""|$)|'(?:[^'\\]|\\[\S\s])*(?:'|$)|"(?:[^"\\]|\\[\S\s])*(?:"|$))/, q, "'\""]) : a.multiLineStrings ? m.push(["str", /^(?:'(?:[^'\\]|\\[\S\s])*(?:'|$)|"(?:[^"\\]|\\[\S\s])*(?:"|$)|`(?:[^\\`]|\\[\S\s])*(?:`|$))/, q, "'\"`"]) : m.push(["str", /^(?:'(?:[^\n\r'\\]|\\.)*(?:'|$)|"(?:[^\n\r"\\]|\\.)*(?:"|$))/, q, "\"'"]);
        a.verbatimStrings && e.push(["str", /^@"(?:[^"]|"")*(?:"|$)/, q]);
        var h = a.hashComments;
        h && (a.cStyleComments ? (h > 1 ? m.push(["com", /^#(?:##(?:[^#]|#(?!##))*(?:###|$)|.*)/, q, "#"]) : m.push(["com", /^#(?:(?:define|elif|else|endif|error|ifdef|include|ifndef|line|pragma|undef|warning)\b|[^\n\r]*)/, q, "#"]), e.push(["str", /^<(?:(?:(?:\.\.\/)*|\/?)(?:[\w-]+(?:\/[\w-]+)+)?[\w-]+\.h|[a-z]\w*)>/, q])) : m.push(["com", /^#[^\n\r]*/, q, "#"]));
        a.cStyleComments && (e.push(["com", /^\/\/[^\n\r]*/, q]), e.push(["com", /^\/\*[\S\s]*?(?:\*\/|$)/, q]));
        a.regexLiterals && e.push(["lang-regex", /^(?:^^\.?|[!+-]|!=|!==|#|%|%=|&|&&|&&=|&=|\(|\*|\*=|\+=|,|-=|->|\/|\/=|:|::|;|<|<<|<<=|<=|=|==|===|>|>=|>>|>>=|>>>|>>>=|[?@[^]|\^=|\^\^|\^\^=|{|\||\|=|\|\||\|\|=|~|break|case|continue|delete|do|else|finally|instanceof|return|throw|try|typeof)\s*(\/(?=[^*/])(?:[^/[\\]|\\[\S\s]|\[(?:[^\\\]]|\\[\S\s])*(?:]|$))+\/)/]);
        (h = a.types) && e.push(["typ", h]);
        a = ("" + a.keywords).replace(/^ | $/g, "");
        a.length && e.push(["kwd", RegExp("^(?:" + a.replace(/[\s,]+/g, "|") + ")\\b"), q]);
        m.push(["pln", /^\s+/, q, " \r\n\t\xa0"]);
        e.push(["lit", /^@[$_a-z][\w$@]*/i, q], ["typ", /^(?:[@_]?[A-Z]+[a-z][\w$@]*|\w+_t\b)/, q], ["pln", /^[$_a-z][\w$@]*/i, q], ["lit", /^(?:0x[\da-f]+|(?:\d(?:_\d+)*\d*(?:\.\d*)?|\.\d\+)(?:e[+-]?\d+)?)[a-z]*/i, q, "0123456789"], ["pln", /^\\[\S\s]?/, q], ["pun", /^.[^\s\w"-$'./@\\`]*/, q]);
        return x(m, e)
    }

    function D(a, m) {
        function e(a) {
            switch (a.nodeType) {
            case 1:
                if (k.test(a.className)) break;
                if ("BR" === a.nodeName) h(a), a.parentNode && a.parentNode.removeChild(a);
                else
                    for (a = a.firstChild; a; a = a.nextSibling) e(a);
                break;
            case 3:
            case 4:
                if (p) {
                    var b = a.nodeValue,
                        d = b.match(t);
                    if (d) {
                        var c = b.substring(0, d.index);
                        a.nodeValue = c;
                        (b = b.substring(d.index + d[0].length)) && a.parentNode.insertBefore(s.createTextNode(b), a.nextSibling);
                        h(a);
                        c || a.parentNode.removeChild(a)
                    }
                }
            }
        }

        function h(a) {
            function b(a, d) {
                var e = d ? a.cloneNode(!1) : a,
                    f = a.parentNode;
                if (f) {
                    var f = b(f, 1),
                        g = a.nextSibling;
                    f.appendChild(e);
                    for (var h = g; h; h = g) g = h.nextSibling, f.appendChild(h)
                }
                return e
            }
            for (; !a.nextSibling;)
                if (a = a.parentNode, !a) return;
            for (var a = b(a.nextSibling, 0), e;
                (e = a.parentNode) && e.nodeType === 1;) a = e;
            d.push(a)
        }
        var k = /(?:^|\s)nocode(?:\s|$)/,
            t = /\r\n?|\n/,
            s = a.ownerDocument,
            l;
        a.currentStyle ? l = a.currentStyle.whiteSpace : window.getComputedStyle && (l = s.defaultView.getComputedStyle(a, q).getPropertyValue("white-space"));
        var p = l && "pre" === l.substring(0, 3);
        for (l = s.createElement("LI"); a.firstChild;) l.appendChild(a.firstChild);
        for (var d = [l], g = 0; g < d.length; ++g) e(d[g]);
        m === (m | 0) && d[0].setAttribute("value", m);
        var r = s.createElement("OL");
        r.className = "linenums";
        for (var n = Math.max(0, m - 1 | 0) || 0, g = 0, z = d.length; g < z; ++g) l = d[g], l.className = "L" + (g + n) % 10, l.firstChild || l.appendChild(s.createTextNode("\xa0")), r.appendChild(l);
        a.appendChild(r)
    }

    function k(a, m) {
        for (var e = m.length; --e >= 0;) {
            var h = m[e];
            A.hasOwnProperty(h) ? window.console && console.warn("cannot override language handler %s", h) : A[h] = a
        }
    }

    function C(a, m) {
        if (!a || !A.hasOwnProperty(a)) a = /^\s*</.test(m) ? "default-markup" : "default-code";
        return A[a]
    }

    function E(a) {
        var m = a.g;
        try {
            var e = M(a.h),
                h = e.a;
            a.a = h;
            a.c = e.c;
            a.d = 0;
            C(m, h)(a);
            var k = /\bMSIE\b/.test(navigator.userAgent),
                m = /\n/g,
                t = a.a,
                s = t.length,
                e = 0,
                l = a.c,
                p = l.length,
                h = 0,
                d = a.e,
                g = d.length,
                a = 0;
            d[g] = s;
            var r, n;
            for (n = r = 0; n < g;) d[n] !== d[n + 2] ? (d[r++] = d[n++], d[r++] = d[n++]) : n += 2;
            g = r;
            for (n = r = 0; n < g;) {
                for (var z = d[n], f = d[n + 1], b = n + 2; b + 2 <= g && d[b + 1] === f;) b += 2;
                d[r++] = z;
                d[r++] = f;
                n = b
            }
            for (d.length = r; h < p;) {
                var o = l[h + 2] || s,
                    c = d[a + 2] || s,
                    b = Math.min(o, c),
                    i = l[h + 1],
                    j;
                if (i.nodeType !== 1 && (j = t.substring(e, b))) {
                    k && (j = j.replace(m, "\r"));
                    i.nodeValue = j;
                    var u = i.ownerDocument,
                        v = u.createElement("SPAN");
                    v.className = d[a + 1];
                    var x = i.parentNode;
                    x.replaceChild(v, i);
                    v.appendChild(i);
                    e < o && (l[h + 1] = i = u.createTextNode(t.substring(b, o)), x.insertBefore(i, v.nextSibling))
                }
                e = b;
                e >= o && (h += 2);
                e >= c && (a += 2)
            }
        } catch (w) {
            "console" in window && console.log(w && w.stack ? w.stack : w)
        }
    }
    var v = ["break,continue,do,else,for,if,return,while"],
        w = [
            [v, "auto,case,char,const,default,double,enum,extern,float,goto,int,long,register,short,signed,sizeof,static,struct,switch,typedef,union,unsigned,void,volatile"], "catch,class,delete,false,import,new,operator,private,protected,public,this,throw,true,try,typeof"
        ],
        F = [w, "alignof,align_union,asm,axiom,bool,concept,concept_map,const_cast,constexpr,decltype,dynamic_cast,explicit,export,friend,inline,late_check,mutable,namespace,nullptr,reinterpret_cast,static_assert,static_cast,template,typeid,typename,using,virtual,where"],
        G = [w, "abstract,boolean,byte,extends,final,finally,implements,import,instanceof,null,native,package,strictfp,super,synchronized,throws,transient"],
        H = [G, "as,base,by,checked,decimal,delegate,descending,dynamic,event,fixed,foreach,from,group,implicit,in,interface,internal,into,is,lock,object,out,override,orderby,params,partial,readonly,ref,sbyte,sealed,stackalloc,string,select,uint,ulong,unchecked,unsafe,ushort,var"],
        w = [w, "debugger,eval,export,function,get,null,set,undefined,var,with,Infinity,NaN"],
        I = [v, "and,as,assert,class,def,del,elif,except,exec,finally,from,global,import,in,is,lambda,nonlocal,not,or,pass,print,raise,try,with,yield,False,True,None"],
        J = [v, "alias,and,begin,case,class,def,defined,elsif,end,ensure,false,in,module,next,nil,not,or,redo,rescue,retry,self,super,then,true,undef,unless,until,when,yield,BEGIN,END"],
        v = [v, "case,done,elif,esac,eval,fi,function,in,local,set,then,until"],
        K = /^(DIR|FILE|vector|(de|priority_)?queue|list|stack|(const_)?iterator|(multi)?(set|map)|bitset|u?(int|float)\d*)/,
        N = /\S/,
        O = u({
            keywords: [F, H, w, "caller,delete,die,do,dump,elsif,eval,exit,foreach,for,goto,if,import,last,local,my,next,no,our,print,package,redo,require,sub,undef,unless,until,use,wantarray,while,BEGIN,END" +
                I, J, v
            ],
            hashComments: !0,
            cStyleComments: !0,
            multiLineStrings: !0,
            regexLiterals: !0
        }),
        A = {};
    k(O, ["default-code"]);
    k(x([], [
        ["pln", /^[^<?]+/],
        ["dec", /^<!\w[^>]*(?:>|$)/],
        ["com", /^<\!--[\S\s]*?(?:--\>|$)/],
        ["lang-", /^<\?([\S\s]+?)(?:\?>|$)/],
        ["lang-", /^<%([\S\s]+?)(?:%>|$)/],
        ["pun", /^(?:<[%?]|[%?]>)/],
        ["lang-", /^<xmp\b[^>]*>([\S\s]+?)<\/xmp\b[^>]*>/i],
        ["lang-js", /^<script\b[^>]*>([\S\s]*?)(<\/script\b[^>]*>)/i],
        ["lang-css", /^<style\b[^>]*>([\S\s]*?)(<\/style\b[^>]*>)/i],
        ["lang-in.tag", /^(<\/?[a-z][^<>]*>)/i]
    ]), ["default-markup", "htm", "html", "mxml", "xhtml", "xml", "xsl"]);
    k(x([
        ["pln", /^\s+/, q, " \t\r\n"],
        ["atv", /^(?:"[^"]*"?|'[^']*'?)/, q, "\"'"]
    ], [
        ["tag", /^^<\/?[a-z](?:[\w-.:]*\w)?|\/?>$/i],
        ["atn", /^(?!style[\s=]|on)[a-z](?:[\w:-]*\w)?/i],
        ["lang-uq.val", /^=\s*([^\s"'>]*(?:[^\s"'/>]|\/(?=\s)))/],
        ["pun", /^[/<->]+/],
        ["lang-js", /^on\w+\s*=\s*"([^"]+)"/i],
        ["lang-js", /^on\w+\s*=\s*'([^']+)'/i],
        ["lang-js", /^on\w+\s*=\s*([^\s"'>]+)/i],
        ["lang-css", /^style\s*=\s*"([^"]+)"/i],
        ["lang-css", /^style\s*=\s*'([^']+)'/i],
        ["lang-css", /^style\s*=\s*([^\s"'>]+)/i]
    ]), ["in.tag"]);
    k(x([], [
        ["atv", /^[\S\s]+/]
    ]), ["uq.val"]);
    k(u({
        keywords: F,
        hashComments: !0,
        cStyleComments: !0,
        types: K
    }), ["c", "cc", "cpp", "cxx", "cyc", "m"]);
    k(u({
        keywords: "null,true,false"
    }), ["json"]);
    k(u({
        keywords: H,
        hashComments: !0,
        cStyleComments: !0,
        verbatimStrings: !0,
        types: K
    }), ["cs"]);
    k(u({
        keywords: G,
        cStyleComments: !0
    }), ["java"]);
    k(u({
        keywords: v,
        hashComments: !0,
        multiLineStrings: !0
    }), ["bsh", "csh", "sh"]);

    k(u({
        keywords: I,
        hashComments: !0,
        multiLineStrings: !0,
        tripleQuotedStrings: !0
    }), ["cv", "py"]);
    k(u({
        keywords: "caller,delete,die,do,dump,elsif,eval,exit,foreach,for,goto,if,import,last,local,my,next,no,our,print,package,redo,require,sub,undef,unless,until,use,wantarray,while,BEGIN,END",
        hashComments: !0,
        multiLineStrings: !0,
        regexLiterals: !0
    }), ["perl", "pl", "pm"]);
    k(u({
        keywords: J,
        hashComments: !0,
        multiLineStrings: !0,
        regexLiterals: !0
    }), ["rb"]);
    k(u({
        keywords: w,
        cStyleComments: !0,
        regexLiterals: !0
    }), ["js"]);
    k(u({
        keywords: "all,and,by,catch,class,else,extends,false,finally,for,if,in,is,isnt,loop,new,no,not,null,of,off,on,or,return,super,then,true,try,unless,until,when,while,yes",
        hashComments: 3,
        cStyleComments: !0,
        multilineStrings: !0,
        tripleQuotedStrings: !0,
        regexLiterals: !0
    }), ["coffee"]);
    k(x([], [
        ["str", /^[\S\s]+/]
    ]), ["regex"]);
    window.prettyPrintOne = function (a, m, e) {
        var h = document.createElement("PRE");
        h.innerHTML = a;
        e && D(h, e);
        E({
            g: m,
            i: e,
            h: h
        });
        return h.innerHTML
    };
    window.prettyPrint = function (a) {
        function m() {
            for (var e = window.PR_SHOULD_USE_CONTINUATION ? l.now() + 250 : Infinity; p < h.length && l.now() < e; p++) {
                var n = h[p],
                    k = n.className;
                if (k.indexOf("prettyprint") >= 0) {
                    var k = k.match(g),
                        f, b;
                    if (b = !k) {
                        b = n;
                        for (var o = void 0, c = b.firstChild; c; c = c.nextSibling) var i = c.nodeType,
                        o = i === 1 ? o ? b : c : i === 3 ? N.test(c.nodeValue) ? b : o : o;
                        b = (f = o === b ? void 0 : o) && "CODE" === f.tagName
                    }
                    b && (k = f.className.match(g));
                    k && (k = k[1]);
                    b = !1;
                    for (o = n.parentNode; o; o = o.parentNode)
                        if ((o.tagName === "pre" || o.tagName === "code" || o.tagName === "xmp") && o.className && o.className.indexOf("prettyprint") >= 0) {
                            b = !0;
                            break
                        }
                    b || ((b = (b = n.className.match(/\blinenums\b(?::(\d+))?/)) ? b[1] && b[1].length ? +b[1] : !0 : !1) && D(n, b), d = {
                        g: k,
                        h: n,
                        i: b
                    }, E(d))
                }
            }
            p < h.length ? setTimeout(m, 250) : a && a()
        }
        for (var e = [document.getElementsByTagName("pre"), document.getElementsByTagName("code"), document.getElementsByTagName("xmp")], h = [], k = 0; k < e.length; ++k)
            for (var t = 0, s = e[k].length; t < s; ++t) h.push(e[k][t]);
        var e = q,
            l = Date;
        l.now || (l = {
            now: function () {
                return +new Date
            }
        });
        var p = 0,
            d, g = /\blang(?:uage)?-([\w.]+)(?!\S)/;
        m()
    };
    window.PR = {
        createSimpleLexer: x,
        registerLangHandler: k,
        sourceDecorator: u,
        PR_ATTRIB_NAME: "atn",
        PR_ATTRIB_VALUE: "atv",
        PR_COMMENT: "com",
        PR_DECLARATION: "dec",
        PR_KEYWORD: "kwd",
        PR_LITERAL: "lit",
        PR_NOCODE: "nocode",
        PR_PLAIN: "pln",
        PR_PUNCTUATION: "pun",
        PR_SOURCE: "src",
        PR_STRING: "str",
        PR_TAG: "tag",
        PR_TYPE: "typ"
    }
})();;
! function (a) {
    a(function () {
        "use strict", a.support.transition = function () {
            var a = function () {
                var a = document.createElement("bootstrap"),
                    b = {
                        WebkitTransition: "webkitTransitionEnd",
                        MozTransition: "transitionend",
                        OTransition: "oTransitionEnd",
                        msTransition: "MSTransitionEnd",
                        transition: "transitionend"
                    }, c;
                for (c in b)
                    if (a.style[c] !== undefined) return b[c]
            }();
            return a && {
                end: a
            }
        }()
    })
}(window.jQuery), ! function (a) {
    "use strict";
    var b = '[data-dismiss="alert"]',
        c = function (c) {
            a(c).on("click", b, this.close)
        };
    c.prototype.close = function (b) {
        function f() {
            e.trigger("closed").remove()
        }
        var c = a(this),
            d = c.attr("data-target"),
            e;
        d || (d = c.attr("href"), d = d && d.replace(/.*(?=#[^\s]*$)/, "")), e = a(d), b && b.preventDefault(), e.length || (e = c.hasClass("alert") ? c : c.parent()), e.trigger(b = a.Event("close"));
        if (b.isDefaultPrevented()) return;
        e.removeClass("in"), a.support.transition && e.hasClass("fade") ? e.on(a.support.transition.end, f) : f()
    }, a.fn.alert = function (b) {
        return this.each(function () {
            var d = a(this),
                e = d.data("alert");
            e || d.data("alert", e = new c(this)), typeof b == "string" && e[b].call(d)
        })
    }, a.fn.alert.Constructor = c, a(function () {
        a("body").on("click.alert.data-api", b, c.prototype.close)
    })
}(window.jQuery), ! function (a) {
    "use strict";
    var b = function (b, c) {
        this.$element = a(b), this.options = a.extend({}, a.fn.button.defaults, c)
    };
    b.prototype.setState = function (a) {
        var b = "disabled",
            c = this.$element,
            d = c.data(),
            e = c.is("input") ? "val" : "html";
        a += "Text", d.resetText || c.data("resetText", c[e]()), c[e](d[a] || this.options[a]), setTimeout(function () {
            a == "loadingText" ? c.addClass(b).attr(b, b) : c.removeClass(b).removeAttr(b)
        }, 0)
    }, b.prototype.toggle = function () {
        var a = this.$element.parent('[data-toggle="buttons-radio"]');
        a && a.find(".active").removeClass("active"), this.$element.toggleClass("active")
    }, a.fn.button = function (c) {
        return this.each(function () {
            var d = a(this),
                e = d.data("button"),
                f = typeof c == "object" && c;
            e || d.data("button", e = new b(this, f)), c == "toggle" ? e.toggle() : c && e.setState(c)
        })
    }, a.fn.button.defaults = {
        loadingText: "loading..."
    }, a.fn.button.Constructor = b, a(function () {
        a("body").on("click.button.data-api", "[data-toggle^=button]", function (b) {
            var c = a(b.target);
            c.hasClass("btn") || (c = c.closest(".btn")), c.button("toggle")
        })
    })
}(window.jQuery), ! function (a) {
    "use strict";
    var b = function (b, c) {
        this.$element = a(b), this.options = c, this.options.slide && this.slide(this.options.slide), this.options.pause == "hover" && this.$element.on("mouseenter", a.proxy(this.pause, this)).on("mouseleave", a.proxy(this.cycle, this))
    };
    b.prototype = {
        cycle: function (b) {
            return b || (this.paused = !1), this.options.interval && !this.paused && (this.interval = setInterval(a.proxy(this.next, this), this.options.interval)), this
        },
        to: function (b) {
            var c = this.$element.find(".active"),
                d = c.parent().children(),
                e = d.index(c),
                f = this;
            if (b > d.length - 1 || b < 0) return;
            return this.sliding ? this.$element.one("slid", function () {
                f.to(b)
            }) : e == b ? this.pause().cycle() : this.slide(b > e ? "next" : "prev", a(d[b]))
        },
        pause: function (a) {
            return a || (this.paused = !0), clearInterval(this.interval), this.interval = null, this
        },
        next: function () {
            if (this.sliding) return;
            return this.slide("next")
        },
        prev: function () {
            if (this.sliding) return;
            return this.slide("prev")
        },
        slide: function (b, c) {
            var d = this.$element.find(".active"),
                e = c || d[b](),
                f = this.interval,
                g = b == "next" ? "left" : "right",
                h = b == "next" ? "first" : "last",
                i = this,
                j = a.Event("slide");
            this.sliding = !0, f && this.pause(), e = e.length ? e : this.$element.find(".item")[h]();
            if (e.hasClass("active")) return;
            if (a.support.transition && this.$element.hasClass("slide")) {
                this.$element.trigger(j);
                if (j.isDefaultPrevented()) return;
                e.addClass(b), e[0].offsetWidth, d.addClass(g), e.addClass(g), this.$element.one(a.support.transition.end, function () {
                    e.removeClass([b, g].join(" ")).addClass("active"), d.removeClass(["active", g].join(" ")), i.sliding = !1, setTimeout(function () {
                        i.$element.trigger("slid")
                    }, 0)
                })
            } else {
                this.$element.trigger(j);
                if (j.isDefaultPrevented()) return;
                d.removeClass("active"), e.addClass("active"), this.sliding = !1, this.$element.trigger("slid")
            }
            return f && this.cycle(), this
        }
    }, a.fn.carousel = function (c) {
        return this.each(function () {
            var d = a(this),
                e = d.data("carousel"),
                f = a.extend({}, a.fn.carousel.defaults, typeof c == "object" && c);
            e || d.data("carousel", e = new b(this, f)), typeof c == "number" ? e.to(c) : typeof c == "string" || (c = f.slide) ? e[c]() : f.interval && e.cycle()
        })
    }, a.fn.carousel.defaults = {
        interval: 5e3,
        pause: "hover"
    }, a.fn.carousel.Constructor = b, a(function () {
        a("body").on("click.carousel.data-api", "[data-slide]", function (b) {
            var c = a(this),
                d, e = a(c.attr("data-target") || (d = c.attr("href")) && d.replace(/.*(?=#[^\s]+$)/, "")),
                f = !e.data("modal") && a.extend({}, e.data(), c.data());
            e.carousel(f), b.preventDefault()
        })
    })
}(window.jQuery), ! function (a) {
    "use strict";
    var b = function (b, c) {
        this.$element = a(b), this.options = a.extend({}, a.fn.collapse.defaults, c), this.options.parent && (this.$parent = a(this.options.parent)), this.options.toggle && this.toggle()
    };
    b.prototype = {
        constructor: b,
        dimension: function () {
            var a = this.$element.hasClass("width");
            return a ? "width" : "height"
        },
        show: function () {
            var b, c, d, e;
            if (this.transitioning) return;
            b = this.dimension(), c = a.camelCase(["scroll", b].join("-")), d = this.$parent && this.$parent.find("> .accordion-group > .in");
            if (d && d.length) {
                e = d.data("collapse");
                if (e && e.transitioning) return;
                d.collapse("hide"), e || d.data("collapse", null)
            }
            this.$element[b](0), this.transition("addClass", a.Event("show"), "shown"), this.$element[b](this.$element[0][c])
        },
        hide: function () {
            var b;
            if (this.transitioning) return;
            b = this.dimension(), this.reset(this.$element[b]()), this.transition("removeClass", a.Event("hide"), "hidden"), this.$element[b](0)
        },
        reset: function (a) {
            var b = this.dimension();
            return this.$element.removeClass("collapse")[b](a || "auto")[0].offsetWidth, this.$element[a !== null ? "addClass" : "removeClass"]("collapse"), this
        },
        transition: function (b, c, d) {
            var e = this,
                f = function () {
                    c.type == "show" && e.reset(), e.transitioning = 0, e.$element.trigger(d)
                };
            this.$element.trigger(c);
            if (c.isDefaultPrevented()) return;
            this.transitioning = 1, this.$element[b]("in"), a.support.transition && this.$element.hasClass("collapse") ? this.$element.one(a.support.transition.end, f) : f()
        },
        toggle: function () {
            this[this.$element.hasClass("in") ? "hide" : "show"]()
        }
    }, a.fn.collapse = function (c) {
        return this.each(function () {
            var d = a(this),
                e = d.data("collapse"),
                f = typeof c == "object" && c;
            e || d.data("collapse", e = new b(this, f)), typeof c == "string" && e[c]()
        })
    }, a.fn.collapse.defaults = {
        toggle: !0
    }, a.fn.collapse.Constructor = b, a(function () {
        a("body").on("click.collapse.data-api", "[data-toggle=collapse]", function (b) {
            var c = a(this),
                d, e = c.attr("data-target") || b.preventDefault() || (d = c.attr("href")) && d.replace(/.*(?=#[^\s]+$)/, ""),
                f = a(e).data("collapse") ? "toggle" : c.data();
            a(e).collapse(f)
        })
    })
}(window.jQuery), ! function (a) {
    function d() {
        a(b).parent().removeClass("open")
    }
    "use strict";
    var b = '[data-toggle="dropdown"]',
        c = function (b) {
            var c = a(b).on("click.dropdown.data-api", this.toggle);
            a("html").on("click.dropdown.data-api", function () {
                c.parent().removeClass("open")
            })
        };
    c.prototype = {
        constructor: c,
        toggle: function (b) {
            var c = a(this),
                e, f, g;
            if (c.is(".disabled, :disabled")) return;
            return f = c.attr("data-target"), f || (f = c.attr("href"), f = f && f.replace(/.*(?=#[^\s]*$)/, "")), e = a(f), e.length || (e = c.parent()), g = e.hasClass("open"), d(), g || e.toggleClass("open"), !1
        }
    }, a.fn.dropdown = function (b) {
        return this.each(function () {
            var d = a(this),
                e = d.data("dropdown");
            e || d.data("dropdown", e = new c(this)), typeof b == "string" && e[b].call(d)
        })
    }, a.fn.dropdown.Constructor = c, a(function () {
        a("html").on("click.dropdown.data-api", d), a("body").on("click.dropdown", ".dropdown form", function (a) {
            a.stopPropagation()
        }).on("click.dropdown.data-api", b, c.prototype.toggle)
    })
}(window.jQuery), ! function (a) {
    function c() {
        var b = this,
            c = setTimeout(function () {
                b.$element.off(a.support.transition.end), d.call(b)
            }, 500);
        this.$element.one(a.support.transition.end, function () {
            clearTimeout(c), d.call(b)
        })
    }

    function d(a) {
        this.$element.hide().trigger("hidden"), e.call(this)
    }

    function e(b) {
        var c = this,
            d = this.$element.hasClass("fade") ? "fade" : "";
        if (this.isShown && this.options.backdrop) {
            var e = a.support.transition && d;
            this.$backdrop = a('<div class="modal-backdrop ' + d + '" />').appendTo(document.body), this.options.backdrop != "static" && this.$backdrop.click(a.proxy(this.hide, this)), e && this.$backdrop[0].offsetWidth, this.$backdrop.addClass("in"), e ? this.$backdrop.one(a.support.transition.end, b) : b()
        } else !this.isShown && this.$backdrop ? (this.$backdrop.removeClass("in"), a.support.transition && this.$element.hasClass("fade") ? this.$backdrop.one(a.support.transition.end, a.proxy(f, this)) : f.call(this)) : b && b()
    }

    function f() {
        this.$backdrop.remove(), this.$backdrop = null
    }

    function g() {
        var b = this;
        this.isShown && this.options.keyboard ? a(document).on("keyup.dismiss.modal", function (a) {
            a.which == 27 && b.hide()
        }) : this.isShown || a(document).off("keyup.dismiss.modal")
    }
    "use strict";
    var b = function (b, c) {
        this.options = c, this.$element = a(b).delegate('[data-dismiss="modal"]', "click.dismiss.modal", a.proxy(this.hide, this))
    };
    b.prototype = {
        constructor: b,
        toggle: function () {
            return this[this.isShown ? "hide" : "show"]()
        },
        show: function () {
            var b = this,
                c = a.Event("show");
            this.$element.trigger(c);
            if (this.isShown || c.isDefaultPrevented()) return;
            a("body").addClass("modal-open"), this.isShown = !0, g.call(this), e.call(this, function () {
                var c = a.support.transition && b.$element.hasClass("fade");
                b.$element.parent().length || b.$element.appendTo(document.body), b.$element.show(), c && b.$element[0].offsetWidth, b.$element.addClass("in"), c ? b.$element.one(a.support.transition.end, function () {
                    b.$element.trigger("shown")
                }) : b.$element.trigger("shown")
            })
        },
        hide: function (b) {
            b && b.preventDefault();
            var e = this;
            b = a.Event("hide"), this.$element.trigger(b);
            if (!this.isShown || b.isDefaultPrevented()) return;
            this.isShown = !1, a("body").removeClass("modal-open"), g.call(this), this.$element.removeClass("in"), a.support.transition && this.$element.hasClass("fade") ? c.call(this) : d.call(this)
        }
    }, a.fn.modal = function (c) {
        return this.each(function () {
            var d = a(this),
                e = d.data("modal"),
                f = a.extend({}, a.fn.modal.defaults, d.data(), typeof c == "object" && c);
            e || d.data("modal", e = new b(this, f)), typeof c == "string" ? e[c]() : f.show && e.show()
        })
    }, a.fn.modal.defaults = {
        backdrop: !0,
        keyboard: !0,
        show: !0
    }, a.fn.modal.Constructor = b, a(function () {
        a("body").on("click.modal.data-api", '[data-toggle="modal"]', function (b) {
            var c = a(this),
                d, e = a(c.attr("data-target") || (d = c.attr("href")) && d.replace(/.*(?=#[^\s]+$)/, "")),
                f = e.data("modal") ? "toggle" : a.extend({}, e.data(), c.data());
            b.preventDefault(), e.modal(f)
        })
    })
}(window.jQuery), ! function (a) {
    "use strict";
    var b = function (a, b) {
        this.init("tooltip", a, b)
    };
    b.prototype = {
        constructor: b,
        init: function (b, c, d) {
            var e, f;
            this.type = b, this.$element = a(c), this.options = this.getOptions(d), this.enabled = !0, this.options.trigger != "manual" && (e = this.options.trigger == "hover" ? "mouseenter" : "focus", f = this.options.trigger == "hover" ? "mouseleave" : "blur", this.$element.on(e, this.options.selector, a.proxy(this.enter, this)), this.$element.on(f, this.options.selector, a.proxy(this.leave, this))), this.options.selector ? this._options = a.extend({}, this.options, {
                trigger: "manual",
                selector: ""
            }) : this.fixTitle()
        },
        getOptions: function (b) {
            return b = a.extend({}, a.fn[this.type].defaults, b, this.$element.data()), b.delay && typeof b.delay == "number" && (b.delay = {
                show: b.delay,
                hide: b.delay
            }), b
        },
        enter: function (b) {
            var c = a(b.currentTarget)[this.type](this._options).data(this.type);
            if (!c.options.delay || !c.options.delay.show) return c.show();
            clearTimeout(this.timeout), c.hoverState = "in", this.timeout = setTimeout(function () {
                c.hoverState == "in" && c.show()
            }, c.options.delay.show)
        },
        leave: function (b) {
            var c = a(b.currentTarget)[this.type](this._options).data(this.type);
            if (!c.options.delay || !c.options.delay.hide) return c.hide();
            clearTimeout(this.timeout), c.hoverState = "out", this.timeout = setTimeout(function () {
                c.hoverState == "out" && c.hide()
            }, c.options.delay.hide)
        },
        show: function () {
            var a, b, c, d, e, f, g;
            if (this.hasContent() && this.enabled) {
                a = this.tip(), this.setContent(), this.options.animation && a.addClass("fade"), f = typeof this.options.placement == "function" ? this.options.placement.call(this, a[0], this.$element[0]) : this.options.placement, b = /in/.test(f), a.remove().css({
                    top: 0,
                    left: 0,
                    display: "block"
                }).appendTo(b ? this.$element : document.body), c = this.getPosition(b), d = a[0].offsetWidth, e = a[0].offsetHeight;
                switch (b ? f.split(" ")[1] : f) {
                case "bottom":
                    g = {
                        top: c.top + c.height,
                        left: c.left + c.width / 2 - d / 2
                    };
                    break;
                case "top":
                    g = {
                        top: c.top - e,
                        left: c.left + c.width / 2 - d / 2
                    };
                    break;
                case "left":
                    g = {
                        top: c.top + c.height / 2 - e / 2,
                        left: c.left - d
                    };
                    break;
                case "right":
                    g = {
                        top: c.top + c.height / 2 - e / 2,
                        left: c.left + c.width
                    }
                }
                a.css(g).addClass(f).addClass("in")
            }
        },
        isHTML: function (a) {
            return typeof a != "string" || a.charAt(0) === "<" && a.charAt(a.length - 1) === ">" && a.length >= 3 || /^(?:[^<]*<[\w\W]+>[^>]*$)/.exec(a)
        },
        setContent: function () {
            var a = this.tip(),
                b = this.getTitle();
            a.find(".tooltip-inner")[this.isHTML(b) ? "html" : "text"](b), a.removeClass("fade in top bottom left right")
        },
        hide: function () {
            function d() {
                var b = setTimeout(function () {
                    c.off(a.support.transition.end).remove()
                }, 500);
                c.one(a.support.transition.end, function () {
                    clearTimeout(b), c.remove()
                })
            }
            var b = this,
                c = this.tip();
            c.removeClass("in"), a.support.transition && this.$tip.hasClass("fade") ? d() : c.remove()
        },
        fixTitle: function () {
            var a = this.$element;
            (a.attr("title") || typeof a.attr("data-original-title") != "string") && a.attr("data-original-title", a.attr("title") || "").removeAttr("title")
        },
        hasContent: function () {
            return this.getTitle()
        },
        getPosition: function (b) {
            return a.extend({}, b ? {
                top: 0,
                left: 0
            } : this.$element.offset(), {
                width: this.$element[0].offsetWidth,
                height: this.$element[0].offsetHeight
            })
        },
        getTitle: function () {
            var a, b = this.$element,
                c = this.options;
            return a = b.attr("data-original-title") || (typeof c.title == "function" ? c.title.call(b[0]) : c.title), a
        },
        tip: function () {
            return this.$tip = this.$tip || a(this.options.template)
        },
        validate: function () {

            this.$element[0].parentNode || (this.hide(), this.$element = null, this.options = null)
        },
        enable: function () {
            this.enabled = !0
        },
        disable: function () {
            this.enabled = !1
        },
        toggleEnabled: function () {
            this.enabled = !this.enabled
        },
        toggle: function () {
            this[this.tip().hasClass("in") ? "hide" : "show"]()
        }
    }, a.fn.tooltip = function (c) {
        return this.each(function () {
            var d = a(this),
                e = d.data("tooltip"),
                f = typeof c == "object" && c;
            e || d.data("tooltip", e = new b(this, f)), typeof c == "string" && e[c]()
        })
    }, a.fn.tooltip.Constructor = b, a.fn.tooltip.defaults = {
        animation: !0,
        placement: "top",
        selector: !1,
        template: '<div class="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>',
        trigger: "hover",
        title: "",
        delay: 0
    }
}(window.jQuery), ! function (a) {
    "use strict";
    var b = function (a, b) {
        this.init("popover", a, b)
    };
    b.prototype = a.extend({}, a.fn.tooltip.Constructor.prototype, {
        constructor: b,
        setContent: function () {
            var a = this.tip(),
                b = this.getTitle(),
                c = this.getContent();
            a.find(".popover-title")[this.isHTML(b) ? "html" : "text"](b), a.find(".popover-content > *")[this.isHTML(c) ? "html" : "text"](c), a.removeClass("fade top bottom left right in")
        },
        hasContent: function () {
            return this.getTitle() || this.getContent()
        },
        getContent: function () {
            var a, b = this.$element,
                c = this.options;
            return a = b.attr("data-content") || (typeof c.content == "function" ? c.content.call(b[0]) : c.content), a
        },
        tip: function () {
            return this.$tip || (this.$tip = a(this.options.template)), this.$tip
        }
    }), a.fn.popover = function (c) {
        return this.each(function () {
            var d = a(this),
                e = d.data("popover"),
                f = typeof c == "object" && c;
            e || d.data("popover", e = new b(this, f)), typeof c == "string" && e[c]()
        })
    }, a.fn.popover.Constructor = b, a.fn.popover.defaults = a.extend({}, a.fn.tooltip.defaults, {
        placement: "right",
        content: "",
        template: '<div class="popover"><div class="arrow"></div><div class="popover-inner"><h3 class="popover-title"></h3><div class="popover-content"><p></p></div></div></div>'
    })
}(window.jQuery), ! function (a) {
    function b(b, c) {
        var d = a.proxy(this.process, this),
            e = a(b).is("body") ? a(window) : a(b),
            f;
        this.options = a.extend({}, a.fn.scrollspy.defaults, c), this.$scrollElement = e.on("scroll.scroll.data-api", d), this.selector = (this.options.target || (f = a(b).attr("href")) && f.replace(/.*(?=#[^\s]+$)/, "") || "") + " .nav li > a", this.$body = a("body"), this.refresh(), this.process()
    }
    "use strict", b.prototype = {
        constructor: b,
        refresh: function () {
            var b = this,
                c;
            this.offsets = a([]), this.targets = a([]), c = this.$body.find(this.selector).map(function () {
                var b = a(this),
                    c = b.data("target") || b.attr("href"),
                    d = /^#\w/.test(c) && a(c);
                return d && c.length && [
                    [d.position().top, c]
                ] || null
            }).sort(function (a, b) {
                return a[0] - b[0]
            }).each(function () {
                b.offsets.push(this[0]), b.targets.push(this[1])
            })
        },
        process: function () {
            var a = this.$scrollElement.scrollTop() + this.options.offset,
                b = this.$scrollElement[0].scrollHeight || this.$body[0].scrollHeight,
                c = b - this.$scrollElement.height(),
                d = this.offsets,
                e = this.targets,
                f = this.activeTarget,
                g;
            if (a >= c) return f != (g = e.last()[0]) && this.activate(g);
            for (g = d.length; g--;) f != e[g] && a >= d[g] && (!d[g + 1] || a <= d[g + 1]) && this.activate(e[g])
        },
        activate: function (b) {
            var c, d;
            this.activeTarget = b, a(this.selector).parent(".active").removeClass("active"), d = this.selector + '[data-target="' + b + '"],' + this.selector + '[href="' + b + '"]', c = a(d).parent("li").addClass("active"), c.parent(".dropdown-menu") && (c = c.closest("li.dropdown").addClass("active")), c.trigger("activate")
        }
    }, a.fn.scrollspy = function (c) {
        return this.each(function () {
            var d = a(this),
                e = d.data("scrollspy"),
                f = typeof c == "object" && c;
            e || d.data("scrollspy", e = new b(this, f)), typeof c == "string" && e[c]()
        })
    }, a.fn.scrollspy.Constructor = b, a.fn.scrollspy.defaults = {
        offset: 10
    }, a(function () {
        a('[data-spy="scroll"]').each(function () {
            var b = a(this);
            b.scrollspy(b.data())
        })
    })
}(window.jQuery), ! function (a) {
    "use strict";
    var b = function (b) {
        this.element = a(b)
    };
    b.prototype = {
        constructor: b,
        show: function () {
            var b = this.element,
                c = b.closest("ul:not(.dropdown-menu)"),
                d = b.attr("data-target"),
                e, f, g;
            d || (d = b.attr("href"), d = d && d.replace(/.*(?=#[^\s]*$)/, ""));
            if (b.parent("li").hasClass("active")) return;
            e = c.find(".active a").last()[0], g = a.Event("show", {
                relatedTarget: e
            }), b.trigger(g);
            if (g.isDefaultPrevented()) return;
            f = a(d), this.activate(b.parent("li"), c), this.activate(f, f.parent(), function () {
                b.trigger({
                    type: "shown",
                    relatedTarget: e
                })
            })
        },
        activate: function (b, c, d) {
            function g() {
                e.removeClass("active").find("> .dropdown-menu > .active").removeClass("active"), b.addClass("active"), f ? (b[0].offsetWidth, b.addClass("in")) : b.removeClass("fade"), b.parent(".dropdown-menu") && b.closest("li.dropdown").addClass("active"), d && d()
            }
            var e = c.find("> .active"),
                f = d && a.support.transition && e.hasClass("fade");
            f ? e.one(a.support.transition.end, g) : g(), e.removeClass("in")
        }
    }, a.fn.tab = function (c) {
        return this.each(function () {
            var d = a(this),
                e = d.data("tab");
            e || d.data("tab", e = new b(this)), typeof c == "string" && e[c]()
        })
    }, a.fn.tab.Constructor = b, a(function () {
        a("body").on("click.tab.data-api", '[data-toggle="tab"], [data-toggle="pill"]', function (b) {
            b.preventDefault(), a(this).tab("show")
        })
    })
}(window.jQuery), ! function (a) {
    "use strict";
    var b = function (b, c) {
        this.$element = a(b), this.options = a.extend({}, a.fn.typeahead.defaults, c), this.matcher = this.options.matcher || this.matcher, this.sorter = this.options.sorter || this.sorter, this.highlighter = this.options.highlighter || this.highlighter, this.updater = this.options.updater || this.updater, this.$menu = a(this.options.menu).appendTo("body"), this.source = this.options.source, this.shown = !1, this.listen()
    };
    b.prototype = {
        constructor: b,
        select: function () {
            var a = this.$menu.find(".active").attr("data-value");
            return this.$element.val(this.updater(a)).change(), this.hide()
        },
        updater: function (a) {
            return a
        },
        show: function () {
            var b = a.extend({}, this.$element.offset(), {
                height: this.$element[0].offsetHeight
            });
            return this.$menu.css({
                top: b.top + b.height,
                left: b.left
            }), this.$menu.show(), this.shown = !0, this
        },
        hide: function () {
            return this.$menu.hide(), this.shown = !1, this
        },
        lookup: function (b) {
            var c = this,
                d, e;
            return this.query = this.$element.val(), this.query ? (d = a.grep(this.source, function (a) {
                return c.matcher(a)
            }), d = this.sorter(d), d.length ? this.render(d.slice(0, this.options.items)).show() : this.shown ? this.hide() : this) : this.shown ? this.hide() : this
        },
        matcher: function (a) {
            return~ a.toLowerCase().indexOf(this.query.toLowerCase())
        },
        sorter: function (a) {
            var b = [],
                c = [],
                d = [],
                e;
            while (e = a.shift()) e.toLowerCase().indexOf(this.query.toLowerCase()) ? ~e.indexOf(this.query) ? c.push(e) : d.push(e) : b.push(e);
            return b.concat(c, d)
        },
        highlighter: function (a) {
            var b = this.query.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g, "\\$&");
            return a.replace(new RegExp("(" + b + ")", "ig"), function (a, b) {
                return "<strong>" + b + "</strong>"
            })
        },
        render: function (b) {
            var c = this;
            return b = a(b).map(function (b, d) {
                return b = a(c.options.item).attr("data-value", d), b.find("a").html(c.highlighter(d)), b[0]
            }), b.first().addClass("active"), this.$menu.html(b), this
        },
        next: function (b) {
            var c = this.$menu.find(".active").removeClass("active"),
                d = c.next();
            d.length || (d = a(this.$menu.find("li")[0])), d.addClass("active")
        },
        prev: function (a) {
            var b = this.$menu.find(".active").removeClass("active"),
                c = b.prev();
            c.length || (c = this.$menu.find("li").last()), c.addClass("active")
        },
        listen: function () {
            this.$element.on("blur", a.proxy(this.blur, this)).on("keypress", a.proxy(this.keypress, this)).on("keyup", a.proxy(this.keyup, this)), (a.browser.webkit || a.browser.msie) && this.$element.on("keydown", a.proxy(this.keypress, this)), this.$menu.on("click", a.proxy(this.click, this)).on("mouseenter", "li", a.proxy(this.mouseenter, this))
        },
        keyup: function (a) {
            switch (a.keyCode) {
            case 40:
            case 38:
                break;
            case 9:
            case 13:
                if (!this.shown) return;
                this.select();
                break;
            case 27:
                if (!this.shown) return;
                this.hide();
                break;
            default:
                this.lookup()
            }
            a.stopPropagation(), a.preventDefault()
        },
        keypress: function (a) {
            if (!this.shown) return;
            switch (a.keyCode) {
            case 9:
            case 13:
            case 27:
                a.preventDefault();
                break;
            case 38:
                if (a.type != "keydown") break;
                a.preventDefault(), this.prev();
                break;
            case 40:
                if (a.type != "keydown") break;
                a.preventDefault(), this.next()
            }
            a.stopPropagation()
        },
        blur: function (a) {
            var b = this;
            setTimeout(function () {
                b.hide()
            }, 150)
        },
        click: function (a) {
            a.stopPropagation(), a.preventDefault(), this.select()
        },
        mouseenter: function (b) {
            this.$menu.find(".active").removeClass("active"), a(b.currentTarget).addClass("active")
        }
    }, a.fn.typeahead = function (c) {
        return this.each(function () {
            var d = a(this),
                e = d.data("typeahead"),
                f = typeof c == "object" && c;
            e || d.data("typeahead", e = new b(this, f)), typeof c == "string" && e[c]()
        })
    }, a.fn.typeahead.defaults = {
        source: [],
        items: 8,
        menu: '<ul class="typeahead dropdown-menu"></ul>',
        item: '<li><a href="#"></a></li>'
    }, a.fn.typeahead.Constructor = b, a(function () {
        a("body").on("focus.typeahead.data-api", '[data-provide="typeahead"]', function (b) {
            var c = a(this);
            if (c.data("typeahead")) return;
            b.preventDefault(), c.typeahead(c.data())
        })
    })
}(window.jQuery);;
(function (a, b, c) {
    function E(b) {
        var c = this,
            d = b.elements,
            e = d.tooltip,
            f = ".bgiframe-" + b.id;
        a.extend(c, {
            init: function () {
                d.bgiframe = a('<iframe class="ui-tooltip-bgiframe" frameborder="0" tabindex="-1" src="javascript:\'\';"  style="display:block; position:absolute; z-index:-1; filter:alpha(opacity=0); -ms-filter:"progid:DXImageTransform.Microsoft.Alpha(Opacity=0)";"></iframe>'), d.bgiframe.appendTo(e), e.bind("tooltipmove" + f, c.adjust)
            },
            adjust: function () {
                var a = b.get("dimensions"),
                    c = b.plugins.tip,
                    f = d.tip,
                    g, h;
                h = parseInt(e.css("border-left-width"), 10) || 0, h = {
                    left: -h,
                    top: -h
                }, c && f && (g = c.corner.precedance === "x" ? ["width", "left"] : ["height", "top"], h[g[1]] -= f[g[0]]()), d.bgiframe.css(h).css(a)
            },
            destroy: function () {
                d.bgiframe.remove(), e.unbind(f)
            }
        }), c.init()
    }

    function D(c) {
        var f = this,
            g = c.options.show.modal,
            i = c.elements,
            j = i.tooltip,
            
            
            m = l + c.id,
            
            q = a(document.body),
            r;
        c.checks.modal = {
            "^show.modal.(on|blur)$": function () {
                f.init(), i.overlay.toggle(j.is(":visible"))
            }
        }, a.extend(f, {
            init: function () {
                if (!g.on) return f;
                r = f.create(), j.attr(o, d).css("z-index", h.modal.zindex + a(n + "[" + o + "]").length).unbind(l).unbind(m).bind("tooltipshow" + l + " tooltiphide" + l, function (b, c, d) {
                    var e = b.originalEvent;
                    if (e && b.type === "tooltiphide" && /mouse(leave|enter)/.test(e.type) && a(e.relatedTarget).closest(r[0]).length) try {
                        b.preventDefault()
                    } catch (g) {} else e && !e.solo && f[b.type.replace("tooltip", "")](b, d)
                }).bind("tooltipfocus" + l, function (b) {
                    if (!b.isDefaultPrevented()) {
                        var c = a(n).filter("[" + o + "]"),
                            d = h.modal.zindex + c.length,
                            e = parseInt(j[0].style.zIndex, 10);
                        
                        try {
                            b.preventDefault()
                        } catch (f) {}
                    }
                }).bind("tooltiphide" + l, function (b) {
                    a("[" + o + "]").filter(":visible").not(j).last().qtip("focus", b)
                }), g.escape && a(b).unbind(m).bind("keydown" + m, function (a) {
                    a.keyCode === 27 && j.hasClass(p) && c.hide(a)
                }), g.blur && i.overlay.unbind(m).bind("click" + m, function (a) {
                    j.hasClass(p) && c.hide(a)
                });
                return f
            },
            create: function () {
                var c = a(k);
                if (c.length) return i.overlay = c.insertAfter(a(n).last());
                r = i.overlay = a("<div />", {
                    id: k.substr(1),
                    html: "<div></div>",
                    mousedown: function () {
                        return e
                    }
                }).insertAfter(a(n).last()), a(b).unbind(l).bind("resize" + l, function () {
                    r.css({
                        height: a(b).height(),
                        width: a(b).width()
                    })
                }).triggerHandler("resize");
                return r
            },
            toggle: function (b, c, h) {
                if (b && b.isDefaultPrevented()) return f;
                var i = g.effect,
                    k = c ? "show" : "hide",
                    l = r.is(":visible"),
                    p = a("[" + o + "]").filter(":visible").not(j),
                    s;
                r || (r = f.create());
                if (r.is(":animated") && l === c || !c && p.length) return f;
                c ? (r.css({
                    left: 0,
                    top: 0
                }), r.toggleClass("blurs", g.blur), q.bind("focusin" + m, function (b) {
                    var c = a(b.target),
                        d = c.closest(".qtip"),
                        f = d.length < 1 ? e : parseInt(d[0].style.zIndex, 10) > parseInt(j[0].style.zIndex, 10);
                    !f && a(b.target).closest(n)[0] !== j[0] && j.find("input:visible").filter(":first").focus()
                })) : q.undelegate("*", "focusin" + m), r.stop(d, e), a.isFunction(i) ? i.call(r, c) : i === e ? r[k]() : r.fadeTo(parseInt(h, 10) || 90, c ? 1 : 0, function () {
                    c || a(this).hide()
                }), c || r.queue(function (a) {
                    r.css({
                        left: "",
                        top: ""
                    }), a()
                });
                return f
            },
            show: function (a, b) {
                return f.toggle(a, d, b)
            },
            hide: function (a, b) {
                return f.toggle(a, e, b)
            },
            destroy: function () {
                var d = r;
                d && (d = a("[" + o + "]").not(j).length < 1, d ? (i.overlay.remove(), a(b).unbind(l)) : i.overlay.unbind(l + c.id), q.undelegate("*", "focusin" + m));
                return j.removeAttr(o).unbind(l)
            }
        }), f.init()
    }

    function C(b, g) {
        function w(a) {
            var b = a.precedance === "y",
                c = n[b ? "width" : "height"],
                d = n[b ? "height" : "width"],
                e = a.string().indexOf("center") > -1,
                f = c * (e ? .5 : 1),
                g = Math.pow,
                h = Math.round,
                i, j, k, l = Math.sqrt(g(f, 2) + g(d, 2)),
                m = [p / f * l, p / d * l];
            m[2] = Math.sqrt(g(m[0], 2) - g(p, 2)), m[3] = Math.sqrt(g(m[1], 2) - g(p, 2)), i = l + m[2] + m[3] + (e ? 0 : m[0]), j = i / l, k = [h(j * d), h(j * c)];
            return {
                height: k[b ? 0 : 1],
                width: k[b ? 1 : 0]
            }
        }

        function v(b) {
            var c = k.titlebar && b.y === "top",
                d = c ? k.titlebar : k.content,
                e = a.browser.mozilla,
                f = e ? "-moz-" : a.browser.webkit ? "-webkit-" : "",
                g = b.y + (e ? "" : "-") + b.x,
                h = f + (e ? "border-radius-" + g : "border-" + g + "-radius");
            return parseInt(d.css(h), 10) || parseInt(l.css(h), 10) || 0
        }

        function u(a, b, c) {
            b = b ? b : a[a.precedance];
            var d = l.hasClass(r),
                e = k.titlebar && a.y === "top",
                f = e ? k.titlebar : k.content,
                g = "border-" + b + "-width",
                h;
            l.addClass(r), h = parseInt(f.css(g), 10), h = (c ? h || parseInt(l.css(g), 10) : h) || 0, l.toggleClass(r, d);
            return h
        }

        function t(f, g, h, l) {
            if (k.tip) {
                var n = a.extend({}, i.corner),
                    o = h.adjusted,
                    p = b.options.position.adjust.method.split(" "),
                    q = p[0],
                    r = p[1] || p[0],
                    s = {
                        left: e,
                        top: e,
                        x: 0,
                        y: 0
                    }, t, u = {}, v;
                i.corner.fixed !== d && (q === "shift" && n.precedance === "x" && o.left && n.y !== "center" ? n.precedance = n.precedance === "x" ? "y" : "x" : q === "flip" && o.left && (n.x = n.x === "center" ? o.left > 0 ? "left" : "right" : n.x === "left" ? "right" : "left"), r === "shift" && n.precedance === "y" && o.top && n.x !== "center" ? n.precedance = n.precedance === "y" ? "x" : "y" : r === "flip" && o.top && (n.y = n.y === "center" ? o.top > 0 ? "top" : "bottom" : n.y === "top" ? "bottom" : "top"), n.string() !== m.corner && (m.top !== o.top || m.left !== o.left) && i.update(n, e)), t = i.position(n, o), t.right !== c && (t.left = -t.right), t.bottom !== c && (t.top = -t.bottom), t.user = Math.max(0, j.offset);
                if (s.left = q === "shift" && !! o.left) n.x === "center" ? u["margin-left"] = s.x = t["margin-left"] - o.left : (v = t.right !== c ? [o.left, -t.left] : [-o.left, t.left], (s.x = Math.max(v[0], v[1])) > v[0] && (h.left -= o.left, s.left = e), u[t.right !== c ? "right" : "left"] = s.x);
                if (s.top = r === "shift" && !! o.top) n.y === "center" ? u["margin-top"] = s.y = t["margin-top"] - o.top : (v = t.bottom !== c ? [o.top, -t.top] : [-o.top, t.top], (s.y = Math.max(v[0], v[1])) > v[0] && (h.top -= o.top, s.top = e), u[t.bottom !== c ? "bottom" : "top"] = s.y);
                k.tip.css(u).toggle(!(s.x && s.y || n.x === "center" && s.y || n.y === "center" && s.x)), h.left -= t.left.charAt ? t.user : q !== "shift" || s.top || !s.left && !s.top ? t.left : 0, h.top -= t.top.charAt ? t.user : r !== "shift" || s.left || !s.left && !s.top ? t.top : 0, m.left = o.left, m.top = o.top, m.corner = n.string()
            }
        }
        var i = this,
            j = b.options.style.tip,
            k = b.elements,
            l = k.tooltip,
            m = {
                top: 0,
                left: 0,
                corner: ""
            }, n = {
                width: j.width,
                height: j.height
            }, o = {}, p = j.border || 0,
            q = ".qtip-tip",
            s = !! (a("<canvas />")[0] || {}).getContext;
        i.mimic = i.corner = f, i.border = p, i.offset = j.offset, i.size = n, b.checks.tip = {
            "^position.my|style.tip.(corner|mimic|border)$": function () {
                i.init() || i.destroy(), b.reposition()
            },
            "^style.tip.(height|width)$": function () {
                n = {
                    width: j.width,
                    height: j.height
                }, i.create(), i.update(), b.reposition()
            },
            "^content.title.text|style.(classes|widget)$": function () {
                k.tip && i.update()
            }
        }, a.extend(i, {
            init: function () {
                var b = i.detectCorner() && (s || a.browser.msie);
                b && (i.create(), i.update(), l.unbind(q).bind("tooltipmove" + q, t));
                return b
            },
            detectCorner: function () {
                var a = j.corner,
                    c = b.options.position,
                    f = c.at,
                    g = c.my.string ? c.my.string() : c.my;
                if (a === e || g === e && f === e) return e;
                a === d ? i.corner = new h.Corner(g) : a.string || (i.corner = new h.Corner(a), i.corner.fixed = d);
                return i.corner.string() !== "centercenter"
            },
            detectColours: function () {
                var c, d, e, f = k.tip.css({
                        backgroundColor: "",
                        border: ""
                    }),
                    g = i.corner,
                    h = g[g.precedance],
                    m = "border-" + h + "-color",
                    p = "border" + h.charAt(0) + h.substr(1) + "Color",
                    q = /rgba?\(0, 0, 0(, 0)?\)|transparent/i,
                    s = "background-color",
                    t = "transparent",
                    u = a(document.body).css("color"),
                    v = b.elements.content.css("color"),
                    w = k.titlebar && (g.y === "top" || g.y === "center" && f.position().top + n.height / 2 + j.offset < k.titlebar.outerHeight(1)),
                    x = w ? k.titlebar : k.content;
                l.addClass(r), o.fill = d = f.css(s), o.border = e = f[0].style[p] || f.css(m) || l.css(m);
                if (!d || q.test(d)) o.fill = x.css(s) || t, q.test(o.fill) && (o.fill = l.css(s) || d);
                if (!e || q.test(e) || e === u) {
                    o.border = x.css(m) || t;
                    if (q.test(o.border) || o.border === v) o.border = e
                }
                a("*", f).add(f).css(s, t).css("border", ""), l.removeClass(r)
            },
            create: function () {
                var b = n.width,
                    c = n.height,
                    d;
                k.tip && k.tip.remove(), k.tip = a("<div />", {
                    "class": "ui-tooltip-tip"
                }).css({
                    width: b,
                    height: c
                }).prependTo(l), s ? a("<canvas />").appendTo(k.tip)[0].getContext("2d").save() : (d = '<vml:shape coordorigin="0,0" style="display:inline-block; position:absolute; behavior:url(#default#VML);"></vml:shape>', k.tip.html(d + d))
            },
            update: function (b, c) {
                var g = k.tip,
                    l = g.children(),
                    m = n.width,
                    q = n.height,
                    r = "px solid ",
                    t = "px dashed transparent",
                    v = j.mimic,
                    x = Math.round,
                    y, z, A, C, D;
                b || (b = i.corner), v === e ? v = b : (v = new h.Corner(v), v.precedance = b.precedance, v.x === "inherit" ? v.x = b.x : v.y === "inherit" ? v.y = b.y : v.x === v.y && (v[b.precedance] = b[b.precedance])), y = v.precedance, i.detectColours(), o.border !== "transparent" && o.border !== "#123456" ? (p = u(b, f, d), j.border === 0 && p > 0 && (o.fill = o.border), i.border = p = j.border !== d ? j.border : p) : i.border = p = 0, A = B(v, m, q), i.size = D = w(b), g.css(D), b.precedance === "y" ? C = [x(v.x === "left" ? p : v.x === "right" ? D.width - m - p : (D.width - m) / 2), x(v.y === "top" ? D.height - q : 0)] : C = [x(v.x === "left" ? D.width - m : 0), x(v.y === "top" ? p : v.y === "bottom" ? D.height - q - p : (D.height - q) / 2)], s ? (l.attr(D), z = l[0].getContext("2d"), z.restore(), z.save(), z.clearRect(0, 0, 3e3, 3e3), z.translate(C[0], C[1]), z.beginPath(), z.moveTo(A[0][0], A[0][1]), z.lineTo(A[1][0], A[1][1]), z.lineTo(A[2][0], A[2][1]), z.closePath(), z.fillStyle = o.fill, z.strokeStyle = o.border, z.lineWidth = p * 2, z.lineJoin = "miter", z.miterLimit = 100, p && z.stroke(), z.fill()) : (A = "m" + A[0][0] + "," + A[0][1] + " l" + A[1][0] + "," + A[1][1] + " " + A[2][0] + "," + A[2][1] + " xe", C[2] = p && /^(r|b)/i.test(b.string()) ? parseFloat(a.browser.version, 10) === 8 ? 2 : 1 : 0, l.css({
                    antialias: "" + (v.string().indexOf("center") > -1),
                    left: C[0] - C[2] * Number(y === "x"),
                    top: C[1] - C[2] * Number(y === "y"),
                    width: m + p,
                    height: q + p
                }).each(function (b) {
                    var c = a(this);
                    c[c.prop ? "prop" : "attr"]({
                        coordsize: m + p + " " + (q + p),
                        path: A,
                        fillcolor: o.fill,
                        filled: !! b,
                        stroked: !b
                    }).css({
                        display: p || b ? "block" : "none"
                    }), !b && c.html() === "" && c.html('<vml:stroke weight="' + p * 2 + 'px" color="' + o.border + '" miterlimit="1000" joinstyle="miter"  style="behavior:url(#default#VML); display:inline-block;" />')
                })), c !== e && i.position(b)
            },
            position: function (b) {
                var c = k.tip,
                    f = {}, g = Math.max(0, j.offset),
                    h, l, m;
                if (j.corner === e || !c) return e;
                b = b || i.corner, h = b.precedance, l = w(b), m = [b.x, b.y], h === "x" && m.reverse(), a.each(m, function (a, c) {
                    var e, i;
                    c === "center" ? (e = h === "y" ? "left" : "top", f[e] = "50%", f["margin-" + e] = -Math.round(l[h === "y" ? "width" : "height"] / 2) + g) : (e = u(b, c, d), i = v(b), f[c] = a ? p ? u(b, c) : 0 : g + (i > e ? i : 0))
                }), f[b[h]] -= l[h === "x" ? "width" : "height"], c.css({
                    top: "",
                    bottom: "",
                    left: "",
                    right: "",
                    margin: ""
                }).css(f);
                return f
            },
            destroy: function () {
                k.tip && k.tip.remove(), l.unbind(q)
            }
        }), i.init()
    }

    function B(a, b, c) {
        var d = Math.ceil(b / 2),
            e = Math.ceil(c / 2),
            f = {
                bottomright: [
                    [0, 0],
                    [b, c],
                    [b, 0]
                ],
                bottomleft: [
                    [0, 0],
                    [b, 0],
                    [0, c]
                ],
                topright: [
                    [0, c],
                    [b, 0],
                    [b, c]
                ],
                topleft: [
                    [0, 0],
                    [0, c],
                    [b, c]
                ],
                topcenter: [
                    [0, c],
                    [d, 0],
                    [b, c]
                ],
                bottomcenter: [
                    [0, 0],
                    [b, 0],
                    [d, c]
                ],
                rightcenter: [
                    [0, 0],
                    [b, e],
                    [0, c]
                ],
                leftcenter: [
                    [b, 0],
                    [b, c],
                    [0, e]
                ]
            };
        f.lefttop = f.bottomright, f.righttop = f.bottomleft, f.leftbottom = f.topright, f.rightbottom = f.topleft;
        return f[a.string()]
    }

    function A(b) {
        var c = this,
            f = b.elements.tooltip,
            g = b.options.content.ajax,
            h = ".qtip-ajax",
            i = /<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi,
            j = d;
        b.checks.ajax = {
            "^content.ajax": function (a, b, d) {
                b === "ajax" && (g = d), b === "once" ? c.init() : g && g.url ? c.load() : f.unbind(h)
            }
        }, a.extend(c, {
            init: function () {
                g && g.url && f.unbind(h)[g.once ? "one" : "bind"]("tooltipshow" + h, c.load);
                return c
            },
            load: function (d, f) {
                function p(a, c, d) {
                    a.status !== 0 && b.set("content.text", c + ": " + d)
                }

                function o(c) {
                    k && (c = a("<div/>").append(c.replace(i, "")).find(k)), b.set("content.text", c)
                }

                function n() {
                    l && (b.show(d.originalEvent), f = e), a.isFunction(g.complete) && g.complete.apply(this, arguments)
                }
                var h = g.url.indexOf(" "),
                    j = g.url,
                    k, l = g.once && !g.loading && f;
                if (l) try {
                    d.preventDefault()
                } catch (m) {} else if (d && d.isDefaultPrevented()) return c;
                h > -1 && (k = j.substr(h), j = j.substr(0, h)), a.ajax(a.extend({
                    success: o,
                    error: p,
                    context: b
                }, g, {
                    url: j,
                    complete: n
                }))
            }
        }), c.init()
    }

    function z(b, c) {
        var i, j, k, l, m, n = a(this),
            o = a(document.body),
            p = this === document ? o : n,
            q = n.metadata ? n.metadata(c.metadata) : f,
            r = c.metadata.type === "html5" && q ? q[c.metadata.name] : f,
            s = n.data(c.metadata.name || "qtipopts");
        try {
            s = typeof s === "string" ? (new Function("return " + s))() : s
        } catch (t) {
            w("Unable to parse HTML5 attribute data: " + s)
        }
        l = a.extend(d, {}, g.defaults, c, typeof s === "object" ? x(s) : f, x(r || q)), j = l.position, l.id = b;
        if ("boolean" === typeof l.content.text) {
            k = n.attr(l.content.attr);
            if (l.content.attr !== e && k) l.content.text = k;
            else {
                w("Unable to locate content for tooltip! Aborting render of tooltip on element: ", n);
                return e
            }
        }
        j.container === e && (j.container = o), j.target === e && (j.target = p), l.show.target === e && (l.show.target = p), l.show.solo === d && (l.show.solo = o), l.hide.target === e && (l.hide.target = p), l.position.viewport === d && (l.position.viewport = j.container), j.at = new h.Corner(j.at), j.my = new h.Corner(j.my);
        if (a.data(this, "qtip"))
            if (l.overwrite) n.qtip("destroy");
            else if (l.overwrite === e) return e;
   
        return i
    }

    function y(s, t, w, y) {
        function R() {
            var c = [t.show.target[0], t.hide.target[0], z.rendered && G.tooltip[0], t.position.container[0], t.position.viewport[0], b, document];
            z.rendered ? a([]).pushStack(a.grep(c, function (a) {
                return typeof a === "object"
            })).unbind(F) : t.show.target.unbind(F + "-create")
        }

        function Q() {
            function p(a) {
                E.is(":visible") && z.reposition(a)
            }

            function o(a) {
                if (E.hasClass(m)) return e;
                clearTimeout(z.timers.inactive), z.timers.inactive = setTimeout(function () {
                    z.hide(a)
                }, t.hide.inactive)
            }

            function l(b) {
                if (E.hasClass(m) || C || D) return e;
                var d = a(b.relatedTarget || b.target),
                    g = d.closest(n)[0] === E[0],
                    h = d[0] === f.show[0];
                clearTimeout(z.timers.show), clearTimeout(z.timers.hide);
                if (c.target === "mouse" && g || t.hide.fixed && (/mouse(out|leave|move)/.test(b.type) && (g || h))) try {
                    b.preventDefault(), b.stopImmediatePropagation()
                } catch (i) {} else t.hide.delay > 0 ? z.timers.hide = setTimeout(function () {
                    z.hide(b)
                }, t.hide.delay) : z.hide(b)
            }

            function k(a) {
                if (E.hasClass(m)) return e;
                f.show.trigger("qtip-" + w + "-inactive"), clearTimeout(z.timers.show), clearTimeout(z.timers.hide);
                var b = function () {
                    z.toggle(d, a)
                };
                t.show.delay > 0 ? z.timers.show = setTimeout(b, t.show.delay) : b()
            }
            var c = t.position,
                f = {
                    show: t.show.target,
                    hide: t.hide.target,
                    viewport: a(c.viewport),
                    document: a(document),
                    window: a(b)
                }, h = {
                    show: a.trim("" + t.show.event).split(" "),
                    hide: a.trim("" + t.hide.event).split(" ")
                }, j = a.browser.msie && parseInt(a.browser.version, 10) === 6;
            E.bind("mouseenter" + F + " mouseleave" + F, function (a) {
                var b = a.type === "mouseenter";
                b && z.focus(a), E.toggleClass(q, b)
            }), t.hide.fixed && (f.hide = f.hide.add(E), E.bind("mouseover" + F, function () {
                E.hasClass(m) || clearTimeout(z.timers.hide)
            })), /mouse(out|leave)/i.test(t.hide.event) ? t.hide.leave === "window" && f.window.bind("mouseout" + F, function (a) {
                /select|option/.test(a.target) && !a.relatedTarget && z.hide(a)
            }) : /mouse(over|enter)/i.test(t.show.event) && f.hide.bind("mouseleave" + F, function (a) {
                clearTimeout(z.timers.show)
            }), ("" + t.hide.event).indexOf("unfocus") > -1 && f.document.bind("mousedown" + F, function (b) {
                var c = a(b.target),
                    d = !E.hasClass(m) && E.is(":visible");
                c[0] !== E[0] && c.parents(n).length === 0 && c.add(s).length > 1 && !c.is(":disabled") && z.hide(b)
            }), "number" === typeof t.hide.inactive && (f.show.bind("qtip-" + w + "-inactive", o), a.each(g.inactiveEvents, function (a, b) {
                f.hide.add(G.tooltip).bind(b + F + "-inactive", o)
            })), a.each(h.hide, function (b, c) {
                var d = a.inArray(c, h.show),
                    e = a(f.hide);
                d > -1 && e.add(f.show).length === e.length || c === "unfocus" ? (f.show.bind(c + F, function (a) {
                    E.is(":visible") ? l(a) : k(a)
                }), delete h.show[d]) : f.hide.bind(c + F, l)
            }), a.each(h.show, function (a, b) {
                f.show.bind(b + F, k)
            }), "number" === typeof t.hide.distance && f.show.add(E).bind("mousemove" + F, function (a) {
                var b = H.origin || {}, c = t.hide.distance,
                    d = Math.abs;
                (d(a.pageX - b.pageX) >= c || d(a.pageY - b.pageY) >= c) && z.hide(a)
            }), c.target === "mouse" && (f.show.bind("mousemove" + F, function (a) {
                i = {
                    pageX: a.pageX,
                    pageY: a.pageY,
                    type: "mousemove"
                }
            }), c.adjust.mouse && (t.hide.event && E.bind("mouseleave" + F, function (a) {
                (a.relatedTarget || a.target) !== f.show[0] && z.hide(a)
            }), f.document.bind("mousemove" + F, function (a) {
                !E.hasClass(m) && E.is(":visible") && z.reposition(a || i)
            }))), (c.adjust.resize || f.viewport.length) && (a.event.special.resize ? f.viewport : f.window).bind("resize" + F, p), (f.viewport.length || j && E.css("position") === "fixed") && f.viewport.bind("scroll" + F, p)
        }

        function P(b, d) {
            function g(b) {
                function i(c) {
                    c && (delete h[c.src], clearTimeout(z.timers.img[c.src]), a(c).unbind(F)), a.isEmptyObject(h) && (z.redraw(), d !== e && z.reposition(H.event), b())
                }
                var g, h = {};
                if ((g = f.find("img:not([height]):not([width])")).length === 0) return i();
                g.each(function (b, d) {
                    if (h[d.src] === c) {
                        var e = 0,
                            f = 3;
                        (function g() {
                            if (d.height || d.width || e > f) return i(d);
                            e += 1, z.timers.img[d.src] = setTimeout(g, 700)
                        })(), a(d).bind("error" + F + " load" + F, function () {
                                i(this)
                            }), h[d.src] = d
                    }
                })
            }
            var f = G.content;
            if (!z.rendered || !b) return e;
            a.isFunction(b) && (b = b.call(s, H.event, z) || ""), b.jquery && b.length > 0 ? f.empty().append(b.css({
                display: "block"
            })) : f.html(b), z.rendered < 0 ? E.queue("fx", g) : (D = 0, g(a.noop));
            return z
        }

        function O(b, c) {
            var d = G.title;
            if (!z.rendered || !b) return e;
            a.isFunction(b) && (b = b.call(s, H.event, z));
            if (b === e) return K(e);
            b.jquery && b.length > 0 ? d.empty().append(b.css({
                display: "block"
            })) : d.html(b), z.redraw(), c !== e && z.rendered && E.is(":visible") && z.reposition(H.event)
        }

        function N(a) {
            var b = G.button,
                c = G.title;
            if (!z.rendered) return e;
            a ? (c || M(), L()) : b.remove()
        }

        function M() {
            var b = B + "-title";
            G.titlebar && K(), G.titlebar = a("<div />", {
                "class": k + "-titlebar " + (t.style.widget ? "ui-widget-header" : "")
            }).append(G.title = a("<div />", {
                id: b,
                "class": k + "-title",
                "aria-atomic": d
            })).insertBefore(G.content).delegate(".ui-state-default", "mousedown keydown mouseup keyup mouseout", function (b) {
                a(this).toggleClass("ui-state-active ui-state-focus", b.type.substr(-4) === "down")
            }).delegate(".ui-state-default", "mouseover mouseout", function (b) {
                a(this).toggleClass("ui-state-hover", b.type === "mouseover")
            }), t.content.title.button ? L() : z.rendered && z.redraw()
        }

        function L() {
            var b = t.content.title.button,
                c = typeof b === "string",
                d = c ? b : "Close tooltip";
            G.button && G.button.remove(), b.jquery ? G.button = b : G.button = a("<a />", {
                "class": "ui-state-default " + (t.style.widget ? "" : k + "-icon"),
                title: d,
                "aria-label": d
            }).prepend(a("<span />", {
                "class": "ui-icon ui-icon-close",
                html: "&times;"
            })), G.button.appendTo(G.titlebar).attr("role", "button").click(function (a) {
                E.hasClass(m) || z.hide(a);
                return e
            }), z.redraw()
        }

        function K(a) {
            G.title && (G.titlebar.remove(), G.titlebar = G.title = G.button = f, a !== e && z.reposition())
        }

        function J() {
            var a = t.style.widget;
            E.toggleClass(l, a).toggleClass(o, !a), G.content.toggleClass(l + "-content", a), G.titlebar && G.titlebar.toggleClass(l + "-header", a), G.button && G.button.toggleClass(k + "-icon", !a)
        }

        function I(a) {
            var b = 0,
                c, d = t,
                e = a.split(".");
            while (d = d[e[b++]]) b < e.length && (c = d);
            return [c || t, e.pop()]
        }
        var z = this,
            A = document.body,
            B = k + "-" + w,
            C = 0,
            D = 0,
            E = a(),
            F = ".qtip-" + w,
            G, H;
        z.id = w, z.rendered = e, z.elements = G = {
            target: s
        }, z.timers = {
            img: {}
        }, z.options = t, z.checks = {}, z.plugins = {}, z.cache = H = {
            event: {},
            target: a(),
            disabled: e,
            attr: y
        }, z.checks.builtin = {
            "^id$": function (b, c, f) {
                var h = f === d ? g.nextid : f,
                    i = k + "-" + h;
                h !== e && h.length > 0 && !a("#" + i).length && (E[0].id = i, G.content[0].id = i + "-content", G.title[0].id = i + "-title")
            },
            "^content.text$": function (a, b, c) {
                P(c)
            },
            "^content.title.text$": function (a, b, c) {
                if (!c) return K();
                !G.title && c && M(), O(c)
            },
            "^content.title.button$": function (a, b, c) {
                N(c)
            },
            "^position.(my|at)$": function (a, b, c) {
                "string" === typeof c && (a[b] = new h.Corner(c))
            },
            "^position.container$": function (a, b, c) {
                z.rendered && E.appendTo(c)
            },
            "^show.ready$": function () {
                z.rendered ? z.toggle(d) : z.render(1)
            },
            "^style.classes$": function (a, b, c) {
                E.attr("class", k + " qtip ui-helper-reset " + c)
            },
            "^style.widget|content.title": J,
            "^events.(render|show|move|hide|focus|blur)$": function (b, c, d) {
                E[(a.isFunction(d) ? "" : "un") + "bind"]("tooltip" + c, d)
            },
            "^(show|hide|position).(event|target|fixed|inactive|leave|distance|viewport|adjust)": function () {
                var a = t.position;
                E.attr("tracking", a.target === "mouse" && a.adjust.mouse), R(), Q()
            }
        }, a.extend(z, {
            render: function (b) {
                if (z.rendered) return z;
                var c = t.content.text,
                    f = t.content.title.text,
                    g = t.position,
                    i = a.Event("tooltiprender");
                a.attr(s[0], "aria-describedbuy", B), E = G.tooltip = a("<div/>", {
                    id: B,
                    "class": k + " qtip ui-helper-reset " + o + " " + t.style.classes + " " + k + "-pos-" + t.position.my.abbreviation(),
                    width: t.style.width || "",
                    height: t.style.height || "",
                    tracking: g.target === "mouse" && g.adjust.mouse,
                    role: "alert",
                    "aria-live": "polite",
                    "aria-atomic": e,
                    "aria-describedby": B + "-content",
                    "aria-hidden": d
                }).toggleClass(m, H.disabled).data("qtip", z).appendTo(t.position.container).append(G.content = a("<div />", {
                    "class": k + "-content",
                    id: B + "-content",
                    "aria-atomic": d
                })), z.rendered = -1, C = D = 1, f && (M(), a.isFunction(f) || O(f, e)), a.isFunction(c) || P(c, e), z.rendered = d, J(), a.each(t.events, function (b, c) {
                    a.isFunction(c) && E.bind(b === "toggle" ? "tooltipshow tooltiphide" : "tooltip" + b, c)
                }), a.each(h, function () {
                    this.initialize === "render" && this(z)
                }), Q(), E.queue("fx", function (a) {
                    i.originalEvent = H.event, E.trigger(i, [z]), C = D = 0, z.redraw(), (t.show.ready || b) && z.toggle(d, H.event), a()
                });
                return z
            },
            get: function (a) {
                var b, c;
                switch (a.toLowerCase()) {
                case "dimensions":
                    b = {
                        height: E.outerHeight(),
                        width: E.outerWidth()
                    };
                    break;
                case "offset":
                    b = h.offset(E, t.position.container);
                    break;
                default:
                    c = I(a.toLowerCase()), b = c[0][c[1]], b = b.precedance ? b.string() : b
                }
                return b
            },
            set: function (b, c) {
                function m(a, b) {
                    var c, d, e;
                    for (c in k)
                        for (d in k[c])
                            if (e = (new RegExp(d, "i")).exec(a)) b.push(e), k[c][d].apply(z, b)
                }
                var g = /^position\.(my|at|adjust|target|container)|style|content|show\.ready/i,
                    h = /^content\.(title|attr)|style/i,
                    i = e,
                    j = e,
                    k = z.checks,
                    l;
                "string" === typeof b ? (l = b, b = {}, b[l] = c) : b = a.extend(d, {}, b), a.each(b, function (c, d) {
                    var e = I(c.toLowerCase()),
                        f;
                    f = e[0][e[1]], e[0][e[1]] = "object" === typeof d && d.nodeType ? a(d) : d, b[c] = [e[0], e[1], d, f], i = g.test(c) || i, j = h.test(c) || j
                }), x(t), C = D = 1, a.each(b, m), C = D = 0, E.is(":visible") && z.rendered && (i && z.reposition(t.position.target === "mouse" ? f : H.event), j && z.redraw());
                return z
            },
            toggle: function (b, c) {
                function q() {
                    b ? (a.browser.msie && E[0].style.removeAttribute("filter"), E.css("overflow", ""), "string" === typeof h.autofocus && a(h.autofocus, E).focus(), p = a.Event("tooltipvisible"), p.originalEvent = c ? H.event : f, E.trigger(p, [z])) : E.css({
                        display: "",
                        visibility: "",
                        opacity: "",
                        left: "",
                        top: ""
                    })
                }
                if (!z.rendered)
                    if (b) z.render(1);
                    else return z;
                var g = b ? "show" : "hide",
                    h = t[g],
                    j = E.is(":visible"),
                    k = !c || t[g].target.length < 2 || H.target[0] === c.target,
                    l = t.position,
                    m = t.content,
                    o, p;
                (typeof b).search("boolean|number") && (b = !j);
                if (!E.is(":animated") && j === b && k) return z;
                if (c) {
                    if (/over|enter/.test(c.type) && /out|leave/.test(H.event.type) && c.target === t.show.target[0] && E.has(c.relatedTarget).length) return z;
                    H.event = a.extend({}, c)
                }
                p = a.Event("tooltip" + g), p.originalEvent = c ? H.event : f, E.trigger(p, [z, 90]);
                if (p.isDefaultPrevented()) return z;
                a.attr(E[0], "aria-hidden", !b), b ? (H.origin = a.extend({}, i), z.focus(c), a.isFunction(m.text) && P(m.text, e), a.isFunction(m.title.text) && O(m.title.text, e), !v && l.target === "mouse" && l.adjust.mouse && (a(document).bind("mousemove.qtip", function (a) {
                    i = {
                        pageX: a.pageX,
                        pageY: a.pageY,
                        type: "mousemove"
                    }
                }), v = d), z.reposition(c), (p.solo = !! h.solo) && a(n, h.solo).not(E).qtip("hide", p)) : (clearTimeout(z.timers.show), delete H.origin, v && !a(n + '[tracking="true"]:visible', h.solo).not(E).length && (a(document).unbind("mousemove.qtip"), v = e), z.blur(c)), k && E.stop(0, 1), h.effect === e ? (E[g](), q.call(E)) : a.isFunction(h.effect) ? (h.effect.call(E, z), E.queue("fx", function (a) {
                    q(), a()
                })) : E.fadeTo(90, b ? 1 : 0, q), b && h.target.trigger("qtip-" + w + "-inactive");
                return z
            },
            show: function (a) {
                return z.toggle(d, a)
            },
            hide: function (a) {
                return z.toggle(e, a)
            },
            focus: function (b) {
                if (!z.rendered) return z;
                var c = a(n),
                    d = parseInt(E[0].style.zIndex, 10),
                    e = g.zindex + c.length,
                    f = a.extend({}, b),
                    h, i;
                E.hasClass(p) || (i = a.Event("tooltipfocus"), i.originalEvent = f, E.trigger(i, [z, e]), i.isDefaultPrevented() || (d !== e && (c.each(function () {
                    this.style.zIndex > d && (this.style.zIndex = this.style.zIndex - 1)
                }), c.filter("." + p).qtip("blur", f)), E.addClass(p)[0].style.zIndex = e));
                return z
            },
            blur: function (b) {
                var c = a.extend({}, b),
                    d;
                E.removeClass(p), d = a.Event("tooltipblur"), d.originalEvent = c, E.trigger(d, [z]);
                return z
            },
            reposition: function (c, d) {
                if (!z.rendered || C) return z;
                C = 1;
                var f = t.position.target,
                    g = t.position,
                    j = g.my,
                    l = g.at,
                    m = g.adjust,
                    n = m.method.split(" "),
                    o = E.outerWidth(),
                    p = E.outerHeight(),
                    q = 0,
                    r = 0,
                    s = a.Event("tooltipmove"),
                    u = E.css("position") === "fixed",
                    v = g.viewport,
                    w = {
                        left: 0,
                        top: 0
                    }, x = e,
                    y = z.plugins.tip,
                    B = {
                        horizontal: n[0],
                        vertical: n[1] = n[1] || n[0],
                        enabled: v.jquery && f[0] !== b && f[0] !== A && m.method !== "none",
                        left: function (a) {
                            var b = B.horizontal === "shift",
                                c = v.offset.left + v.scrollLeft,
                                d = j.x === "left" ? o : j.x === "right" ? -o : -o / 2,
                                e = l.x === "left" ? q : l.x === "right" ? -q : -q / 2,
                                f = y && y.size ? y.size.width || 0 : 0,
                                g = y && y.corner && y.corner.precedance === "x" && !b ? f : 0,
                                h = c - a + g,
                                i = a + o - v.width - c + g,
                                k = d - (j.precedance === "x" || j.x === j.y ? e : 0),
                                n = j.x === "center";
                            b ? (g = y && y.corner && y.corner.precedance === "y" ? f : 0, k = (j.x === "left" ? 1 : -1) * d - g, w.left += h > 0 ? h : i > 0 ? -i : 0, w.left = Math.max(v.offset.left + (g && y.corner.x === "center" ? y.offset : 0), a - k, Math.min(Math.max(v.offset.left + v.width, a + k), w.left))) : (h > 0 && (j.x !== "left" || i > 0) ? w.left -= k : i > 0 && (j.x !== "right" || h > 0) && (w.left -= n ? -k : k), w.left !== a && n && (w.left -= m.x), w.left < c && -w.left > i && (w.left = a));
                            return w.left - a
                        },
                        top: function (a) {
                            var b = B.vertical === "shift",
                                c = v.offset.top + v.scrollTop,
                                d = j.y === "top" ? p : j.y === "bottom" ? -p : -p / 2,
                                e = l.y === "top" ? r : l.y === "bottom" ? -r : -r / 2,
                                f = y && y.size ? y.size.height || 0 : 0,
                                g = y && y.corner && y.corner.precedance === "y" && !b ? f : 0,
                                h = c - a + g,
                                i = a + p - v.height - c + g,
                                k = d - (j.precedance === "y" || j.x === j.y ? e : 0),
                                n = j.y === "center";
                            b ? (g = y && y.corner && y.corner.precedance === "x" ? f : 0, k = (j.y === "top" ? 1 : -1) * d - g, w.top += h > 0 ? h : i > 0 ? -i : 0, w.top = Math.max(v.offset.top + (g && y.corner.x === "center" ? y.offset : 0), a - k, Math.min(Math.max(v.offset.top + v.height, a + k), w.top))) : (h > 0 && (j.y !== "top" || i > 0) ? w.top -= k : i > 0 && (j.y !== "bottom" || h > 0) && (w.top -= n ? -k : k), w.top !== a && n && (w.top -= m.y), w.top < 0 && -w.top > i && (w.top = a));
                            return w.top - a
                        }
                    }, D;
                if (a.isArray(f) && f.length === 2) l = {
                    x: "left",
                    y: "top"
                }, w = {
                    left: f[0],
                    top: f[1]
                };
                else if (f === "mouse" && (c && c.pageX || H.event.pageX)) l = {
                    x: "left",
                    y: "top"
                }, c = (c && (c.type === "resize" || c.type === "scroll") ? H.event : c && c.pageX && c.type === "mousemove" ? c : i && i.pageX && (m.mouse || !c || !c.pageX) ? {
                    pageX: i.pageX,
                    pageY: i.pageY
                } : !m.mouse && H.origin && H.origin.pageX ? H.origin : c) || c || H.event || i || {}, w = {
                    top: c.pageY,
                    left: c.pageX
                };
                else {
                    f === "event" ? c && c.target && c.type !== "scroll" && c.type !== "resize" ? f = H.target = a(c.target) : f = H.target : H.target = a(f), f = a(f).eq(0);
                    if (f.length === 0) return z;
                    f[0] === document || f[0] === b ? (q = h.iOS ? b.innerWidth : f.width(), r = h.iOS ? b.innerHeight : f.height(), f[0] === b && (w = {
                        top: !u || h.iOS ? (v || f).scrollTop() : 0,
                        left: !u || h.iOS ? (v || f).scrollLeft() : 0
                    })) : f.is("area") && h.imagemap ? w = h.imagemap(f, l, B.enabled ? n : e) : f[0].namespaceURI === "http://www.w3.org/2000/svg" && h.svg ? w = h.svg(f, l) : (q = f.outerWidth(), r = f.outerHeight(), w = h.offset(f, g.container)), w.offset && (q = w.width, r = w.height, x = w.flipoffset, w = w.offset);
                    if (h.iOS < 4.1 && h.iOS > 3.1 || h.iOS == 4.3 || !h.iOS && u) D = a(b), w.left -= D.scrollLeft(), w.top -= D.scrollTop();
                    w.left += l.x === "right" ? q : l.x === "center" ? q / 2 : 0, w.top += l.y === "bottom" ? r : l.y === "center" ? r / 2 : 0
                }
                w.left += m.x + (j.x === "right" ? -o : j.x === "center" ? -o / 2 : 0), w.top += m.y + (j.y === "bottom" ? -p : j.y === "center" ? -p / 2 : 0), B.enabled ? (v = {
                    elem: v,
                    height: v[(v[0] === b ? "h" : "outerH") + "eight"](),
                    width: v[(v[0] === b ? "w" : "outerW") + "idth"](),
                    scrollLeft: u ? 0 : v.scrollLeft(),
                    scrollTop: u ? 0 : v.scrollTop(),
                    offset: v.offset() || {
                        left: 0,
                        top: 0
                    }
                }, w.adjusted = {
                    left: B.horizontal !== "none" ? B.left(w.left) : 0,
                    top: B.vertical !== "none" ? B.top(w.top) : 0
                }, w.adjusted.left + w.adjusted.top && E.attr("class", function (a, b) {
                    return b.replace(/ui-tooltip-pos-\w+/i, k + "-pos-" + j.abbreviation())
                }), x && w.adjusted.left && (w.left += x.left), x && w.adjusted.top && (w.top += x.top)) : w.adjusted = {
                    left: 0,
                    top: 0
                }, s.originalEvent = a.extend({}, c), E.trigger(s, [z, w, v.elem || v]);
                if (s.isDefaultPrevented()) return z;
                delete w.adjusted, d === e || isNaN(w.left) || isNaN(w.top) || f === "mouse" || !a.isFunction(g.effect) ? E.css(w) : a.isFunction(g.effect) && (g.effect.call(E, z, a.extend({}, w)), E.queue(function (b) {
                    a(this).css({
                        opacity: "",
                        height: ""
                    }), a.browser.msie && this.style.removeAttribute("filter"), b()
                })), C = 0;
                return z
            },
            redraw: function () {
                if (z.rendered < 1 || D) return z;
                var a = t.position.container,
                    b, c, d, e;
                D = 1, t.style.height && E.css("height", t.style.height), t.style.width ? E.css("width", t.style.width) : (E.css("width", "").addClass(r), c = E.width() + 1, d = E.css("max-width") || "", e = E.css("min-width") || "", b = (d + e).indexOf("%") > -1 ? a.width() / 100 : 0, d = (d.indexOf("%") > -1 ? b : 1) * parseInt(d, 10) || c, e = (e.indexOf("%") > -1 ? b : 1) * parseInt(e, 10) || 0, c = d + e ? Math.min(Math.max(c, e), d) : c, E.css("width", Math.round(c)).removeClass(r)), D = 0;
                return z
            },
            disable: function (b) {
                "boolean" !== typeof b && (b = !E.hasClass(m) && !H.disabled), z.rendered ? (E.toggleClass(m, b), a.attr(E[0], "aria-disabled", b)) : H.disabled = !! b;
                return z
            },
            enable: function () {
                return z.disable(e)
            },
            destroy: function () {
                var b = s[0],
                    c = a.attr(b, u),
                    d = s.data("qtip");
                z.rendered && (E.remove(), a.each(z.plugins, function () {
                    this.destroy && this.destroy()
                })), clearTimeout(z.timers.show), clearTimeout(z.timers.hide), R();
                if (!d || z === d) a.removeData(b, "qtip"), t.suppress && c && (a.attr(b, "title", c), s.removeAttr(u)), s.removeAttr("aria-describedby");
                s.unbind(".qtip-" + w), delete j[z.id];
                return s
            }
        })
    }

    function x(b) {
        var c;
        if (!b || "object" !== typeof b) return e;
        "object" !== typeof b.metadata && (b.metadata = {
            type: b.metadata
        });
        if ("content" in b) {
            if ("object" !== typeof b.content || b.content.jquery) b.content = {
                text: b.content
            };
            c = b.content.text || e, !a.isFunction(c) && (!c && !c.attr || c.length < 1 || "object" === typeof c && !c.jquery) && (b.content.text = e), "title" in b.content && ("object" !== typeof b.content.title && (b.content.title = {
                text: b.content.title
            }), c = b.content.title.text || e, !a.isFunction(c) && (!c && !c.attr || c.length < 1 || "object" === typeof c && !c.jquery) && (b.content.title.text = e))
        }
        "position" in b && ("object" !== typeof b.position && (b.position = {
            my: b.position,
            at: b.position
        })), "show" in b && ("object" !== typeof b.show && (b.show.jquery ? b.show = {
            target: b.show
        } : b.show = {
            event: b.show
        })), "hide" in b && ("object" !== typeof b.hide && (b.hide.jquery ? b.hide = {
            target: b.hide
        } : b.hide = {
            event: b.hide
        })), "style" in b && ("object" !== typeof b.style && (b.style = {
            classes: b.style
        })), a.each(h, function () {
            this.sanitize && this.sanitize(b)
        });
        return b
    }

    function w() {
        w.history = w.history || [], w.history.push(arguments);
        if ("object" === typeof console) {
            var a = console[console.warn ? "warn" : "log"],
                b = Array.prototype.slice.call(arguments),
                c;
            typeof arguments[0] === "string" && (b[0] = "qTip2: " + b[0]), c = a.apply ? a.apply(console, b) : a(b)
        }
    }
    "use strict";
    var d = !0,
        e = !1,
        f = null,
        g, h, i, j = {}, k = "ui-tooltip",
        l = "ui-widget",
        m = "ui-state-disabled",
        n = "div.qtip." + k,
        o = k + "-default",
        p = k + "-focus",
        q = k + "-hover",
        r = k + "-fluid",
        s = "-31000px",
        t = "_replacedByqTip",
        u = "oldtitle",
        v;
    g = a.fn.qtip = function (b, h, i) {
        var j = ("" + b).toLowerCase(),
            k = f,
            l = j === "disable" ? [d] : a.makeArray(arguments).slice(1),
            m = l[l.length - 1],
            n = this[0] ? a.data(this[0], "qtip") : f;
        if (!arguments.length && n || j === "api") return n;
        if ("string" === typeof b) {
            this.each(function () {
                var b = a.data(this, "qtip");
                if (!b) return d;
                m && m.timeStamp && (b.cache.event = m);
                if (j !== "option" && j !== "options" || !h) b[j] && b[j].apply(b[j], l);
                else if (a.isPlainObject(h) || i !== c) b.set(h, i);
                else {
                    k = b.get(h);
                    return e
                }
            });
            return k !== f ? k : this
        }
        if ("object" === typeof b || !arguments.length) {
            n = x(a.extend(d, {}, b));
            return g.bind.call(this, n, m)
        }
    }, g.bind = function (b, f) {
        return this.each(function (k) {
            function r(b) {
                function d() {
                    p.render(typeof b === "object" || l.show.ready), m.show.add(m.hide).unbind(o)
                }
                if (p.cache.disabled) return e;
                p.cache.event = a.extend({}, b), p.cache.target = b ? a(b.target) : [c], l.show.delay > 0 ? (clearTimeout(p.timers.show), p.timers.show = setTimeout(d, l.show.delay), n.show !== n.hide && m.hide.bind(n.hide, function () {
                    clearTimeout(p.timers.show)
                })) : d()
            }
            var l, m, n, o, p, q;
            q = a.isArray(b.id) ? b.id[k] : b.id, q = !q || q === e || q.length < 1 || j[q] ? g.nextid++ : j[q] = q, o = ".qtip-" + q + "-create", p = z.call(this, q, b);
            if (p === e) return d;
            l = p.options, a.each(h, function () {
                this.initialize === "initialize" && this(p)
            }), m = {
                show: l.show.target,
                hide: l.hide.target
            }, n = {
                show: a.trim("" + l.show.event).replace(/ /g, o + " ") + o,
                hide: a.trim("" + l.hide.event).replace(/ /g, o + " ") + o
            }, /mouse(over|enter)/i.test(n.show) && !/mouse(out|leave)/i.test(n.hide) && (n.hide += " mouseleave" + o), m.show.bind("mousemove" + o, function (a) {
                i = {
                    pageX: a.pageX,
                    pageY: a.pageY,
                    type: "mousemove"
                }
            }), m.show.bind(n.show, r), (l.show.ready || l.prerender) && r(f)
        })
    }, h = g.plugins = {
        Corner: function (a) {
            a = ("" + a).replace(/([A-Z])/, " $1").replace(/middle/gi, "center").toLowerCase(), this.x = (a.match(/left|right/i) || a.match(/center/) || ["inherit"])[0].toLowerCase(), this.y = (a.match(/top|bottom|center/i) || ["inherit"])[0].toLowerCase(), this.precedance = a.charAt(0).search(/^(t|b)/) > -1 ? "y" : "x", this.string = function () {
                return this.precedance === "y" ? this.y + this.x : this.x + this.y
            }, this.abbreviation = function () {
                var a = this.x.substr(0, 1),
                    b = this.y.substr(0, 1);
                return a === b ? a : a === "c" || a !== "c" && b !== "c" ? b + a : a + b
            }
        },
        offset: function (a, b) {
            function i(a, b) {
                c.left += b * a.scrollLeft(), c.top += b * a.scrollTop()
            }
            var c = a.offset(),
                d = b,
                e = 0,
                f = document.body,
                g, h;
            if (d) {
                do {
                    d.css("position") !== "static" && (g = d[0] === f ? {
                        left: parseInt(d.css("left"), 10) || 0,
                        top: parseInt(d.css("top"), 10) || 0
                    } : d.position(), c.left -= g.left + (parseInt(d.css("borderLeftWidth"), 10) || 0) + (parseInt(d.css("marginLeft"), 10) || 0), c.top -= g.top + (parseInt(d.css("borderTopWidth"), 10) || 0), h = d.css("overflow"), (h === "scroll" || h === "auto") && ++e);
                    if (d[0] === f) break
                } while (d = d.offsetParent());
                b[0] !== f && e && i(b, 1)
            }
            return c
        },
        iOS: parseFloat(("" + (/CPU.*OS ([0-9_]{1,3})|(CPU like).*AppleWebKit.*Mobile/i.exec(navigator.userAgent) || [0, ""])[1]).replace("undefined", "3_2").replace("_", ".")) || e,
        fn: {
            attr: function (b, c) {
                if (this.length) {
                    var d = this[0],
                        e = "title",
                        f = a.data(d, "qtip");
                    if (b === e && f && "object" === typeof f && f.options.suppress) {
                        if (arguments.length < 2) return a.attr(d, u);
                        f && f.options.content.attr === e && f.cache.attr && f.set("content.text", c);
                        return this.attr(u, c)
                    }
                }
                return a.fn["attr" + t].apply(this, arguments)
            },
            clone: function (b) {
                var c = a([]),
                    d = "title",
                    e = a.fn["clone" + t].apply(this, arguments);
                b || e.filter("[" + u + "]").attr("title", function () {
                    return a.attr(this, u)
                }).removeAttr(u);
                return e
            },
            remove: a.ui ? f : function (b, c) {
                a(this).each(function () {
                    c || (!b || a.filter(b, [this]).length) && a("*", this).add(this).each(function () {
                        a(this).triggerHandler("remove")
                    })
                })
            }
        }
    }, a.each(h.fn, function (b, c) {
        if (!c || a.fn[b + t]) return d;
        var e = a.fn[b + t] = a.fn[b];
        a.fn[b] = function () {
            return c.apply(this, arguments) || e.apply(this, arguments)
        }
    }), g.version = "nightly", g.nextid = 0, g.inactiveEvents = "click dblclick mousedown mouseup mousemove mouseleave mouseenter".split(" "), g.zindex = 15e3, g.defaults = {
        prerender: e,
        id: e,
        overwrite: d,
        suppress: d,
        content: {
            text: d,
            attr: "title",
            title: {
                text: e,
                button: e
            }
        },
        position: {
            my: "top left",
            at: "bottom right",
            target: e,
            container: e,
            viewport: e,
            adjust: {
                x: 0,
                y: 0,
                mouse: d,
                resize: d,
                method: "flip flip"
            },
            effect: function (b, c, d) {
                a(this).animate(c, {
                    duration: 200,
                    queue: e
                })
            }
        },
        show: {
            target: e,
            event: "mouseenter",
            effect: d,
            delay: 90,
            solo: e,
            ready: e,
            autofocus: e
        },
        hide: {
            target: e,
            event: "mouseleave",
            effect: d,
            delay: 0,
            fixed: e,
            inactive: e,
            leave: "window",
            distance: e
        },
        style: {
            classes: "",
            widget: e,
            width: e,
            height: e
        },
        events: {
            render: f,
            move: f,
            show: f,
            hide: f,
            toggle: f,
            visible: f,
            focus: f,
            blur: f
        }
    }, h.ajax = function (a) {
        var b = a.plugins.ajax;
        return "object" === typeof b ? b : a.plugins.ajax = new A(a)
    }, h.ajax.initialize = "render", h.ajax.sanitize = function (a) {
        var b = a.content,
            c;
        b && "ajax" in b && (c = b.ajax, typeof c !== "object" && (c = a.content.ajax = {
            url: c
        }), "boolean" !== typeof c.once && c.once && (c.once = !! c.once))
    }, a.extend(d, g.defaults, {
        content: {
            ajax: {
                loading: d,
                once: d
            }
        }
    }), h.imagemap = function (b, c, d) {
        function n(a, b, c) {
            var d = 0,
                e = 1,
                f = 1,
                g = 0,
                h = 0,
                i = a.width,
                j = a.height;
            while (i > 0 && j > 0 && e > 0 && f > 0) {
                i = Math.floor(i / 2), j = Math.floor(j / 2), c.x === "left" ? e = i : c.x === "right" ? e = a.width - i : e += Math.floor(i / 2), c.y === "top" ? f = j : c.y === "bottom" ? f = a.height - j : f += Math.floor(j / 2), d = b.length;
                while (d--) {
                    if (b.length < 2) break;
                    g = b[d][0] - a.offset.left, h = b[d][1] - a.offset.top, (c.x === "left" && g >= e || c.x === "right" && g <= e || c.x === "center" && (g < e || g > a.width - e) || c.y === "top" && h >= f || c.y === "bottom" && h <= f || c.y === "center" && (h < f || h > a.height - f)) && b.splice(d, 1)
                }
            }
            return {
                left: b[0][0],
                top: b[0][1]
            }
        }
        b.jquery || (b = a(b));
        var e = b.attr("shape").toLowerCase(),
            f = b.attr("coords").split(","),
            g = [],
            h = a('img[usemap="#' + b.parent("map").attr("name") + '"]'),
            i = h.offset(),
            j = {
                width: 0,
                height: 0,
                offset: {
                    top: 1e10,
                    right: 0,
                    bottom: 0,
                    left: 1e10
                }
            }, k = 0,
            l = 0,
            m;
        i.left += Math.ceil((h.outerWidth() - h.width()) / 2), i.top += Math.ceil((h.outerHeight() - h.height()) / 2);
        if (e === "poly") {
            k = f.length;
            while (k--) l = [parseInt(f[--k], 10), parseInt(f[k + 1], 10)], l[0] > j.offset.right && (j.offset.right = l[0]), l[0] < j.offset.left && (j.offset.left = l[0]), l[1] > j.offset.bottom && (j.offset.bottom = l[1]), l[1] < j.offset.top && (j.offset.top = l[1]), g.push(l)
        } else g = a.map(f, function (a) {
            return parseInt(a, 10)
        });
        switch (e) {
        case "rect":
            j = {
                width: Math.abs(g[2] - g[0]),
                height: Math.abs(g[3] - g[1]),
                offset: {
                    left: g[0],
                    top: g[1]
                }
            };
            break;
        case "circle":
            j = {
                width: g[2] + 2,
                height: g[2] + 2,
                offset: {
                    left: g[0],
                    top: g[1]
                }
            };
            break;
        case "poly":
            a.extend(j, {
                width: Math.abs(j.offset.right - j.offset.left),
                height: Math.abs(j.offset.bottom - j.offset.top)
            }), c.string() === "centercenter" ? j.offset = {
                left: j.offset.left + j.width / 2,
                top: j.offset.top + j.height / 2
            } : (j.offset = n(j, g.slice(), c), d && (d[0] === "flip" || d[1] === "flip") && (j.flipoffset = n(j, g.slice(), {
                x: c.x === "left" ? "right" : c.x === "right" ? "left" : "center",
                y: c.y === "top" ? "bottom" : c.y === "bottom" ? "top" : "center"
            }), j.flipoffset.left -= j.offset.left, j.flipoffset.top -= j.offset.top)), j.width = j.height = 0
        }
        j.offset.left += i.left, j.offset.top += i.top;
        return j
    }, h.tip = function (a) {
        var b = a.plugins.tip;
        return "object" === typeof b ? b : a.plugins.tip = new C(a)
    }, h.tip.initialize = "render", h.tip.sanitize = function (a) {
        var b = a.style,
            c;
        b && "tip" in b && (c = a.style.tip, typeof c !== "object" && (a.style.tip = {
            corner: c
        }), /string|boolean/i.test(typeof c.corner) || (c.corner = d), typeof c.width !== "number" && delete c.width, typeof c.height !== "number" && delete c.height, typeof c.border !== "number" && c.border !== d && delete c.border, typeof c.offset !== "number" && delete c.offset)
    }, a.extend(d, g.defaults, {
        style: {
            tip: {
                corner: d,
                mimic: e,
                width: 6,
                height: 6,
                border: d,
                offset: 0
            }
        }
    }), h.svg = function (b, c) {
        var d = a(document),
            e = b[0],
            f = {
                width: 0,
                height: 0,
                offset: {
                    top: 1e10,
                    left: 1e10
                }
            }, g, h, i, j, k;
        if (e.getBBox && e.parentNode) {
            g = e.getBBox(), h = e.getScreenCTM(), i = e.farthestViewportElement || e;
            if (!i.createSVGPoint) return f;
            j = i.createSVGPoint(), j.x = g.x, j.y = g.y, k = j.matrixTransform(h), f.offset.left = k.x, f.offset.top = k.y, j.x += g.width, j.y += g.height, k = j.matrixTransform(h), f.width = k.x - f.offset.left, f.height = k.y - f.offset.top, f.offset.left += d.scrollLeft(), f.offset.top += d.scrollTop()
        }
        return f
    }, h.modal = function (a) {
        var b = a.plugins.modal;
        return "object" === typeof b ? b : a.plugins.modal = new D(a)
    }, h.modal.initialize = "render", h.modal.sanitize = function (a) {
        a.show && (typeof a.show.modal !== "object" ? a.show.modal = {
            on: !! a.show.modal
        } : typeof a.show.modal.on === "undefined" && (a.show.modal.on = d))
    }, h.modal.zindex = g.zindex -= 200, a.extend(d, g.defaults, {
        show: {
            modal: {
                on: e,
                effect: d,
                blur: d,
                escape: d
            }
        }
    }), h.bgiframe = function (b) {
        var c = a.browser,
            d = b.plugins.bgiframe;
        if (a("select, object").length < 1 || (!c.msie || c.version.charAt(0) !== "6")) return e;
        return "object" === typeof d ? d : b.plugins.bgiframe = new E(b)
    }, h.bgiframe.initialize = "render"
})(jQuery, window);
$(function () {
    function spocti() {
        var size = $("[name='size'].active").val();
        var color = $("[name='color'].active").val();
        var type = $("[name='type'].active").val();
        var state = $("[name='state'].active").val();
        var includeicon = $("[name='includeicon'].active").val();
        var iconcolor = $("[name='iconcolor'].active").val();
        var iconposition = $("[name='iconposition'].active").val();
        var text = $("#text").val();
        var icon = $('.the-icons .active i').attr('class');
        if (type != 'input' && type != 'submit') {
            var icon_html = (includeicon == 1 ? '<i class="' + (iconcolor ? iconcolor + ' ' : '') + icon + '"></i>' : '');
            var icon_space = (text != "" && includeicon == 1 ? ' ' : '');
            var html = '<' + type + (type == 'a' ? ' href="#"' : '') + ' class="' + color + (size ? ' ' + size : '') + (state ? ' ' + state : '') + '">' + (iconposition != 'right' ? icon_html + icon_space : '') + htmlspecialchars(text) + (iconposition == 'right' ? icon_space + icon_html : '') + '</' + type + '>';
        } else {
            var html = '<input type="' + (type == 'input' ? 'button' : type) + '" class="' + color + (size ? ' ' + size : '') + (state ? ' ' + state : '') + '" value="' + htmlspecialchars(text) + '"/>';
        }
        $('#result').html(html);
        $('pre').text(html);
        prettyPrint();
    }
    $('#result > a, #result > button').live('click', function (e) {
        e.preventDefault();
    });
    $('.form-inline :input').on('click keyup', function () {
        $(this).parent().find(':input').removeClass('active');
        $(this).addClass('active');
        spocti();
    });
    $('.form-inline :input:first').keyup();
    $('.the-icons a').live('click', function () {
        $('.the-icons a').removeClass('active');
        $(this).addClass('active');
        spocti();
        return false;
    });
    $("[name='includeicon']").click(function () {
        if ($(this).val() == 1) {
            $("[name='includeicon']:eq(0)").addClass('btn-success').find('i').addClass('icon-white');
            $("[name='includeicon']:eq(1)").removeClass('btn-danger').find('i').removeClass('icon-white');
            $('.hide_if_no_icon').show();
        } else {
            $("[name='includeicon']:eq(0)").removeClass('btn-success').find('i').removeClass('icon-white');
            $("[name='includeicon']:eq(1)").addClass('btn-danger').find('i').addClass('icon-white');
            $('.hide_if_no_icon').hide();
        }
    });
    $("[name='type']").click(function () {
        if ($(this).val() == "input" || $(this).val() == "submit") {
            $('.hide_if_no_icon, .hide_if_input').hide();
        } else {
            if ($("[name='includeicon'].active").val() == 1) {
                $('.hide_if_no_icon').show();
            }
            $('.hide_if_input').show();
        }
    });
    $('#clipboard').zclip({
        path: 'js/ZeroClipboard.swf',
        copy: function () {
            return $('#result').html();
        },
        afterCopy: function () {
            $('#after').show().delay(1000).fadeOut('slow');
        }
    });
    $('.help').live('mouseover', function (event) {
        $(this).qtip({
            overwrite: false,
            content: {
                attr: 'title'
            },
            style: {
                classes: 'ui-tooltip-tipsy ui-tooltip-shadow ui-tooltip-rounded'
            },
            position: {
                my: ($(this).data('my') ? $(this).data('my') : 'bottom left'),
                at: ($(this).data('at') ? $(this).data('at') : 'top center'),
                viewport: $(window),
                adjust: {
                    method: 'shift flip',
                    x: 0,
                    y: 0
                }
            },
            show: {
                event: event.type,
                ready: true
            },
            hide: {
                event: 'mouseleave'
            }
        }, event);
    });
    $('.the-icons a').live('mouseover', function (event) {
        $(this).qtip({
            overwrite: false,
            content: {
                text: $('i', this).attr('class')
            },
            style: {
                classes: 'ui-tooltip-tipsy ui-tooltip-shadow ui-tooltip-rounded'
            },
            position: {
                my: 'bottom center',
                at: 'top center',
                viewport: $(window),
                adjust: {
                    method: 'shift flip',
                    x: 0,
                    y: 0
                }
            },
            show: {
                event: event.type,
                ready: true
            },
            hide: {
                event: 'mouseleave'
            }
        }, event);
    });
    $('.validate').validate({
        onkeyup: false,
        errorClass: 'search_error',
        validClass: 'valid',
        errorPlacement: function (error, element) {
            var elem = $(element);
            if (!error.is(':empty')) {
                elem.filter(':not(.valid)').qtip({
                    overwrite: false,
                    content: error,
                    position: {
                        my: 'top left',
                        at: 'bottom left',
                        viewport: $(window)
                    },
                    show: {
                        event: false,
                        ready: true
                    },
                    hide: false,
                    style: {
                        classes: 'ui-tooltip-shadow ui-tooltip-rounded ui-tooltip-red'
                    }
                }).qtip('option', 'content.text', error);
            } else {
                elem.qtip('destroy');
            }
        },
        success: $.noop,
        meta: 'validate'
    });
});

function htmlspecialchars(string, quote_style, charset, double_encode) {
    var optTemp = 0,
        i = 0,
        noquotes = false;
    if (typeof quote_style === 'undefined' || quote_style === null) {
        quote_style = 2;
    }
    string = string.toString();
    if (double_encode !== false) {
        string = string.replace(/&/g, '&amp;');
    }
    string = string.replace(/</g, '&lt;').replace(/>/g, '&gt;');
    var OPTS = {
        'ENT_NOQUOTES': 0,
        'ENT_HTML_QUOTE_SINGLE': 1,
        'ENT_HTML_QUOTE_DOUBLE': 2,
        'ENT_COMPAT': 2,
        'ENT_QUOTES': 3,
        'ENT_IGNORE': 4
    };
    if (quote_style === 0) {
        noquotes = true;
    }
    if (typeof quote_style !== 'number') {
        quote_style = [].concat(quote_style);
        for (i = 0; i < quote_style.length; i++) {
            if (OPTS[quote_style[i]] === 0) {
                noquotes = true;
            } else if (OPTS[quote_style[i]]) {
                optTemp = optTemp | OPTS[quote_style[i]];
            }
        }
        quote_style = optTemp;
    }
    if (quote_style & OPTS.ENT_HTML_QUOTE_SINGLE) {
        string = string.replace(/'/g, '&#039;');
    }
    if (!noquotes) {
        string = string.replace(/"/g, '&quot;');
    }
    return string;
}